//----------------------------------------------------------------------------//
//  GameViewController.h
//  SARURIS
//  Created by Takashi Kawasaki.
//  Creation date    2012/1/27
//  Last update date 2012/5/18
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// H-1 フレームワークをインポートしようブロック
//-------------------------------------------------//
#import <UIKit/UIKit.h>
#import <AVFoundation/AVFoundation.h>  
#import <AudioToolbox/AudioServices.h>
#import <MediaPlayer/MediaPlayer.h>
#import <GameKit/GameKit.h>
#import <Twitter/Twitter.h>
#import <Accounts/Accounts.h>

#pragma mark -
#pragma mark H-2 クラスとインスタンス変数の宣言をしようブロック
//-------------------------------------------------//
// H-2 クラスとインスタンス変数の宣言をしようブロック
//-------------------------------------------------//
@interface GameViewController : UIViewController <UIScrollViewDelegate,MPMediaPickerControllerDelegate,UIAccelerometerDelegate,UIApplicationDelegate>
{
 	// このクラスの中で横断的に使用するインスタンス変数を設定します。
    // 各種イメージビュー
    UIImageView             *bgImgView_; 
	UIImageView             *frameImgView_;
    UIImageView             *boardImgView_;
    
    UIImageView             *leafNormalImgView_;
    UIImageView             *leafMoreImgView_;
    
    UIImageView             *scoreImgView1_;
    UIImageView             *scoreImgView2_;
    UIImageView             *scoreImgView3_;
    UIImageView             *scoreImgView4_;
    UIImageView             *scoreImgView5_;
    UIImageView             *scoreImgView6_;
    UIImageView             *scoreImgView7_;
    UIImageView             *scoreImgView8_;
    UIImageView             *scoreImgView9_;
    
    // 各種スクロールビュー
    UIScrollView            *padScrView_;
    UIScrollView            *helpScrView_;
    
    UIScrollView            *pauseScrView_;
    UIScrollView            *gameOverScrView_;
    
    UIScrollView            *rightRouletteScrView_;
    UIScrollView            *leftRouletteScrView_;
    
    UIImageView             *masuImgView_;
    UIImageView             *frameImageImgView_;
    
    UIImageView             *rightRouletteImgView_;
    UIImageView             *rightShadowImgView_;
    UIImageView             *leftRouletteImgView_;
    UIImageView             *leftShadowImgView_;
    
    UIImageView             *rightBlockImgView1_;
    UIImageView             *rightBlockImgView2_;
    UIImageView             *rightBlockImgView3_;
    UIImageView             *rightBlockImgView4_;
    UIImageView             *rightBlockImgView5_;
    UIImageView             *rightBlockImgView6_;
    UIImageView             *rightBlockImgView7_;
    
    UIImageView             *leftBlockImgView1_;
    UIImageView             *leftBlockImgView2_;
    UIImageView             *leftBlockImgView3_;
    UIImageView             *leftBlockImgView4_;
    
    UIImageView             *pauseTitleImgView_;
    UIImageView             *helpScreenImgView1_;
    UIImageView             *helpScreenImgView2_;
    UIImageView             *helpScreenImgView3_;
    
    UIImageView             *excellentTitleImgView_;
    UIImageView             *gameStartTitleImgView_;
    UIImageView             *gameOverTitleImgView_;
    
    // 各種ボタン
    IBOutlet UIButton       *exitButton_;
    UIButton                *helpButton_;
    UIButton                *backButton_;
    UIButton                *helpBackButton_;
    UIButton                *tweetButton_;
    
    UIButton                *rightButton_;
    UIButton                *leftButton_;
    UIButton                *rotateButton_;
    UIButton                *downButton_;
    UIButton                *pauseButton_;
    
    // タイマー
    NSTimer                 *gameTimer_;
    
    // 各種配列
    NSMutableArray          *dataArray_;
    NSMutableArray          *blockArray_;
    NSMutableArray          *blockArraySP_;    
        
    // 各種サウンド
    AVAudioPlayer           *gameAudioNormal_;
    AVAudioPlayer           *gameAudioPanic_;
    
    SystemSoundID           gameSound1_;
    SystemSoundID           gameSound2_;
    SystemSoundID           gameSound3_;
    SystemSoundID           gameSound4_;
    SystemSoundID           gameSound5_;
    SystemSoundID           gameSound6_;
    SystemSoundID           gameSound7_;
    SystemSoundID           gameSound8_;
    SystemSoundID           gameSound9_;
    SystemSoundID           gameSound10_;
    SystemSoundID           gameSound11_;
    SystemSoundID           gameSound12_;
    SystemSoundID           gameSound13_;
    SystemSoundID           gameSound14_;
    SystemSoundID           gameSound15_;
    SystemSoundID           gameSound16_;
    
    MPMusicPlayerController *musicPlayer_;
    
    // 文字列
    NSString                *bgmTitle_;    
    
    // 数字（フラグ）
    int                     soundType_;
    
    // 数字
    int                     scale_;
    int                     score_;
    float                   speed_;
    int                     difficulty_;
    float                   audioVolume_;
    int                     effectType_;
    
    int                     angleR_;
    int                     angleL_;
    
	float                   accelX_;
    float                   accelY_;
    float                   accelZ_;
	float                   vx_;
    float                   vy_;
	float                   posX_; 
    float                   posY_; 
    
    int                     clearCount_;
    int                     moveCount_;
    int                     timerCount_;
    
    int                     blockSize_;
    
    // BOOL型
    BOOL                    downSkipFlg_;
    BOOL                    addSkipFlg_;
    BOOL                    effectSkipFlg_;
    BOOL                    rouletteSkipFlg_;
    BOOL                    allSkipFlg_;
    BOOL                    clearTrapFlg_;
    BOOL                    gameOverFlg_;
}

#pragma mark -
#pragma mark H-3 アクセサメソッドの宣言をしようブロック
//-------------------------------------------------//
// H-3 アクセサメソッドの宣言をしようブロック
//-------------------------------------------------//
// （アクセサメソッドはここでは不使用）

#pragma mark -
#pragma mark H-4 オリジナルメソッドの宣言をしようブロック
//-------------------------------------------------//
// H-4 オリジナルメソッドの宣言をしようブロック
//-------------------------------------------------//
// ビューの詳細設定
- (void)configureView;

// ゲームコントロールについての各種処理
- (void)gameStart;
- (void)gameControl;
- (void)gamePause;
- (void)gameResume;
- (void)showHelp;
- (void)hideHelp;
- (void)gameOver;
- (void)gameExit;

// ボタン操作についての各種処理
- (void)leftMove;
- (void)rightMove;
- (void)rotateBlock;
- (void)dropBlock:(id)sender;

// ブロック動作についての各種処理
- (BOOL)downBlock;
- (void)checkBlock;
- (void)clearBlock;
- (void)addBlock;
- (void)dispBlock;

// ルーレット動作についての各種処理
- (void)turnLeftRoulette;
- (void)turnRightRoulette;

// 特殊効果についての各種処理
- (void)boardDown;
- (void)scoreUp;
- (void)scoreDown;

- (void)speedUp;
- (void)speedDown;
- (void)resetSpeed;

- (void)stickyTrap;
- (void)stickyTrap2;

- (void)happyTyphoon;
- (void)happyTyphoon2;
- (void)happyTyphoon3;
- (void)happyTyphoon4;

- (void)boardUpHalf;
- (void)effectDuration;
- (void)boardUpFull;
- (void)restartGame;

// その他ボードについての各種処理
- (void)startBoardHide;
- (void)startBoardRemove;

- (void)excellentShow;
- (void)excellentHide;
- (void)excellentRemove;

// その他処理
- (void)checkDifficulty;
- (void)playSound:(NSInteger)soundType;

// 葉っぱの処理
- (void)moveReef;

// GameCenterへの処理
- (void)submitScore:(NSInteger)score forCategory:(NSString *)category;

// Twitter関連の処理
- (void)checkTwitter;
- (void)showTwitter;

//-------------------------------------------------//
// H-5 ヘッダーファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
