//----------------------------------------------------------------------------//
//  GameViewController.m
//  SARURIS
//  Created by Takashi Kawasaki.
//  Creation date    2012/1/27
//  Last update date 2012/5/18
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "GameViewController.h"
#import "CONST.h"

//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
#pragma mark -
#pragma mark M-2 クラスとアクセサメソッドの実装をしようブロック

@implementation GameViewController
// （アクセサメソッドはここでは不使用）

//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
#pragma mark -
#pragma mark M-3 まずはここに処理を書こうブロック

- (void)viewDidLoad
{
    [super viewDidLoad];

    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
#pragma mark -
#pragma mark M-4 ビューを好きなだけイジろうブロック

- (void)configureView
{
    //-- STEP1 --------------------//
    // ユーザーデフォルトから保存データを読み出します。
    //-----------------------------//
	NSUserDefaults *userDefaults    = [NSUserDefaults standardUserDefaults];
    difficulty_                     = [userDefaults integerForKey:@"difficulty"];
    float buttonAlpha               = [userDefaults floatForKey:@"buttonAlpha"];
    audioVolume_                    = [userDefaults floatForKey:@"audioVolume"];
    bgmTitle_                       = [userDefaults stringForKey:@"backgroundMusicTitle"];
    
    //-- STEP2 --------------------//
    // サイズの設定をします（iPhone用/iPad用）
    //-----------------------------//
    // ボタン事前生成
    rotateButton_       = [UIButton buttonWithType:UIButtonTypeCustom];
    downButton_         = [UIButton buttonWithType:UIButtonTypeCustom];
    rightButton_        = [UIButton buttonWithType:UIButtonTypeCustom];
    leftButton_         = [UIButton buttonWithType:UIButtonTypeCustom];
    pauseButton_        = [UIButton buttonWithType:UIButtonTypeCustom];
    backButton_         = [UIButton buttonWithType:UIButtonTypeCustom]; 
    helpButton_         = [UIButton buttonWithType:UIButtonTypeCustom];    
    helpBackButton_     = [UIButton buttonWithType:UIButtonTypeCustom];
    tweetButton_        = [UIButton buttonWithType:UIButtonTypeCustom];
    
    // iPhone固有の設定
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        // 背景の設定
        bgImgView_          = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 480.0)];
        bgImgView_.image    = [UIImage imageWithData:[userDefaults dataForKey:@"backgroundImageData"]];
        
        // マスの設定
        masuImgView_        = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 480.0)];
        masuImgView_.image  = [UIImage imageNamed:@"masu.png"];
        
        // フレーム（枠）の設定
        frameImgView_               = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 480.0)];
        frameImageImgView_          = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 480.0)];
        frameImageImgView_.image    = [UIImage imageNamed:@"frame.png"];
        
        // ルーレットの背景の設定
        rightRouletteScrView_               = [[UIScrollView alloc] initWithFrame:CGRectMake(271.0, 17.0, 40.0, 40.0)];
        leftRouletteScrView_                = [[UIScrollView alloc] initWithFrame:CGRectMake(12.0,  17.0, 40.0, 40.0)];
        rightRouletteScrView_.contentSize   = CGSizeMake(40.0, 280.0);        
        leftRouletteScrView_.contentSize    = CGSizeMake(40.0, 160.0);
        
        rightRouletteImgView_   = [[UIImageView alloc] initWithFrame:CGRectMake(268.0, 4.0, 49.0, 56.5)];
        rightShadowImgView_     = [[UIImageView alloc] initWithFrame:CGRectMake(268.0, 4.0, 49.0, 56.5)];
        leftRouletteImgView_    = [[UIImageView alloc] initWithFrame:CGRectMake(4, 4.0, 49.0, 56.5)];
        leftShadowImgView_      = [[UIImageView alloc] initWithFrame:CGRectMake(4.0, 4.0, 49.0, 56.5)];
        
        // ルーレットの中身の設定
        rightBlockImgView1_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 0.0,   40.0, 40.0)];
        rightBlockImgView2_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 40.0,  40.0, 40.0)];
        rightBlockImgView3_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 80.0,  40.0, 40.0)];
        rightBlockImgView4_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 120.0, 40.0, 40.0)];
        rightBlockImgView5_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 160.0, 40.0, 40.0)];
        rightBlockImgView6_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 200.0, 40.0, 40.0)];
        rightBlockImgView7_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 240.0, 40.0, 40.0)];
        
        leftBlockImgView1_ = [[UIImageView alloc] initWithFrame:CGRectMake(0, 8.75,   40, 22.5)];
        leftBlockImgView2_ = [[UIImageView alloc] initWithFrame:CGRectMake(0, 48.75,  40, 22.5)];
        leftBlockImgView3_ = [[UIImageView alloc] initWithFrame:CGRectMake(0, 88.75,  40, 22.5)];
        leftBlockImgView4_ = [[UIImageView alloc] initWithFrame:CGRectMake(0, 128.75, 40, 22.5)];
        
        scoreImgView1_ = [[UIImageView alloc] initWithFrame:CGRectMake(213.0, 451.0, 13.5, 20.0)];
        scoreImgView2_ = [[UIImageView alloc] initWithFrame:CGRectMake(199.0, 451.0, 13.5, 20.0)];
        scoreImgView3_ = [[UIImageView alloc] initWithFrame:CGRectMake(185.0, 451.0, 13.5, 20.0)];
        scoreImgView4_ = [[UIImageView alloc] initWithFrame:CGRectMake(171.0, 451.0, 13.5, 20.0)];
        scoreImgView5_ = [[UIImageView alloc] initWithFrame:CGRectMake(157.0, 451.0, 13.5, 20.0)];
        scoreImgView6_ = [[UIImageView alloc] initWithFrame:CGRectMake(143.0, 451.0, 13.5, 20.0)];
        scoreImgView7_ = [[UIImageView alloc] initWithFrame:CGRectMake(129.0, 451.0, 13.5, 20.0)];
        scoreImgView8_ = [[UIImageView alloc] initWithFrame:CGRectMake(115.0, 451.0, 13.5, 20.0)];
        scoreImgView9_ = [[UIImageView alloc] initWithFrame:CGRectMake(101.0, 451.0, 13.5, 20.0)];
        
        // ゲームパッドの設定
        padScrView_         = [[UIScrollView alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 480.0)];
        rotateButton_.frame = CGRectMake(265.0, 380.0, 60.0, 60.0);
        downButton_.frame   = CGRectMake(-5.0,  380.0, 60.0, 60.0);
        rightButton_.frame  = CGRectMake(255.0, 280.0, 80.0, 80.0);
        leftButton_.frame   = CGRectMake(-15.0, 280.0, 80.0, 80.0);
        pauseButton_.frame  = CGRectMake(-5.0,  200.0, 60.0, 60.0);
        
        // ポーズ時の画面設定
        pauseScrView_               = [[UIScrollView alloc] initWithFrame:CGRectMake(0.0,  0.0,  320.0, 480.0)];
        pauseScrView_.contentSize   = CGSizeMake(320.0, 480.0);
        pauseTitleImgView_          = [[UIImageView alloc] initWithFrame:CGRectMake(53.0, 60.0, 209.0, 86.0)];
        backButton_.frame           = CGRectMake(100.0, 200.0, 120.0, 34.5);
        helpButton_.frame           = CGRectMake(100.0, 280.0, 120.0, 34.5);
        
        // ヘルプ画面の設定
        helpScrView_                = [[UIScrollView alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 480.0)];
        helpScrView_.contentSize    = CGSizeMake(320.0, 1440.0);
        helpScreenImgView1_         = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 0.0,   320.0, 480.0)];
        helpScreenImgView2_         = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 480.0, 320.0, 480.0)];
        helpScreenImgView3_         = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 960.0, 320.0, 480.0)];
        helpScreenImgView1_.image   = [UIImage imageNamed:NSLocalizedString(@"help1.png", @"")];
        helpScreenImgView2_.image   = [UIImage imageNamed:NSLocalizedString(@"help2.png", @"")];
        helpScreenImgView3_.image   = [UIImage imageNamed:NSLocalizedString(@"help3.png", @"")];
        helpBackButton_.frame       = CGRectMake(0.0, 1400.0, 320.0, 40.0);
        [helpBackButton_ setImage:[UIImage imageNamed:@"btn_helpback.png"] forState:UIControlStateNormal];
        
        // アクションボードの設定
        boardImgView_           = [[UIImageView alloc] initWithFrame:CGRectMake(72.5, -310.0, 175.0, 310.0)];
        excellentTitleImgView_  = [[UIImageView alloc] initWithFrame:CGRectMake(0.0,  0.0,    320.0, 480.0)];
        
        // 葉っぱの設定
        leafNormalImgView_  = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 46.5)];
        leafMoreImgView_    = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, -79.5, 320.0, 79.5)];
        
        // ゲームスタート画面の設定
        gameStartTitleImgView_ = [[UIImageView alloc] initWithFrame:CGRectMake(61.0, 100.0, 198.0, 102.5)];
        
        // ゲームオーバー画面の設定
        gameOverScrView_                = [[UIScrollView alloc] initWithFrame:CGRectMake(0.0,  0.0,  320.0, 480.0)];
        gameOverScrView_.contentSize    = CGSizeMake(320.0, 480.0);
        gameOverTitleImgView_           = [[UIImageView alloc] initWithFrame:CGRectMake(61.0, 100.0, 198.0, 102.5)];        
        tweetButton_.frame              = CGRectMake(100.0, 280.0, 120.0, 34.5);
        
        // Exitボタンの設定
        exitButton_.frame               = CGRectMake(100.0, 360.0, 120.0, 34.5);
        
        // ブロックのサイズ設定
        blockSize_ = kBlockSizeiPhone;
    
    // iPad固有の設定
    }else{
        // 背景の設定
        bgImgView_          = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 0.0, 768.0, 1024.0)];
        bgImgView_.image    = [UIImage imageWithData:[userDefaults dataForKey:@"backgroundImageData"]];
        
        // マスの設定
        masuImgView_        = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 0.0, 768.0, 1024.0)];
        masuImgView_.image  = [UIImage imageNamed:@"masu_ipad.png"];
        
        // フレーム（枠）の設定
        frameImgView_               = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 0.0, 768.0, 1024.0)];
        frameImageImgView_          = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 0.0, 768.0, 1024.0)];
        frameImageImgView_.image    = [UIImage imageNamed:@"frame_ipad.png"];
        
        // ルーレットの背景の設定
        rightRouletteScrView_               = [[UIScrollView alloc] initWithFrame:CGRectMake(617.1, 35.7, 84.0, 84.0)];
        leftRouletteScrView_                = [[UIScrollView alloc] initWithFrame:CGRectMake(73.2,  35.7, 84.0, 84.0)];
        rightRouletteScrView_.contentSize   = CGSizeMake(84.0, 588.0); 
        leftRouletteScrView_.contentSize    = CGSizeMake(84.0, 336.0);
        
        rightRouletteImgView_   = [[UIImageView alloc] initWithFrame:CGRectMake(610.8, 8.4, 102.9, 118.65)];
        rightShadowImgView_     = [[UIImageView alloc] initWithFrame:CGRectMake(610.8, 8.4, 102.9, 118.65)];
        leftRouletteImgView_    = [[UIImageView alloc] initWithFrame:CGRectMake(56.4,   8.4, 102.9, 118.65)];
        leftShadowImgView_      = [[UIImageView alloc] initWithFrame:CGRectMake(56.4,   8.4, 102.9, 118.65)];
        
        // ルーレットの中身の設定
        rightBlockImgView1_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 0.0,   84.0, 84.0)];
        rightBlockImgView2_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 84.0,  84.0, 84.0)];
        rightBlockImgView3_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 168.0, 84.0, 84.0)];
        rightBlockImgView4_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 252.0, 84.0, 84.0)];
        rightBlockImgView5_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 336.0, 84.0, 84.0)];
        rightBlockImgView6_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 420.0, 84.0, 84.0)];
        rightBlockImgView7_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 504.0, 84.0, 84.0)];
        
        leftBlockImgView1_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 18.375,   84.0, 47.25)];
        leftBlockImgView2_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 102.375,  84.0, 47.25)];
        leftBlockImgView3_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 186.375,  84.0, 47.25)];
        leftBlockImgView4_ = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 270.27,   84.0, 47.25)];
        
        scoreImgView1_ = [[UIImageView alloc] initWithFrame:CGRectMake(495.3, 947.1, 28.35, 42.0)];
        scoreImgView2_ = [[UIImageView alloc] initWithFrame:CGRectMake(465.9, 947.1, 28.35, 42.0)];
        scoreImgView3_ = [[UIImageView alloc] initWithFrame:CGRectMake(436.5, 947.1, 28.35, 42.0)];
        scoreImgView4_ = [[UIImageView alloc] initWithFrame:CGRectMake(407.1, 947.1, 28.35, 42.0)];
        scoreImgView5_ = [[UIImageView alloc] initWithFrame:CGRectMake(377.7, 947.1, 28.35, 42.0)];
        scoreImgView6_ = [[UIImageView alloc] initWithFrame:CGRectMake(348.3, 947.1, 28.35, 42.0)];
        scoreImgView7_ = [[UIImageView alloc] initWithFrame:CGRectMake(318.9, 947.1, 28.35, 42.0)];
        scoreImgView8_ = [[UIImageView alloc] initWithFrame:CGRectMake(289.5, 947.1, 28.35, 42.0)];
        scoreImgView9_ = [[UIImageView alloc] initWithFrame:CGRectMake(260.1, 947.1, 28.35, 42.0)];
        
        // ゲームパッドの設定
        padScrView_         = [[UIScrollView alloc] initWithFrame:CGRectMake(0.0, 0.0, 768.0, 1024.0)];
        rotateButton_.frame = CGRectMake(653.5, 798.0, 126.0, 126.0);
        downButton_.frame   = CGRectMake(-10.5, 798.0, 126.0, 126.0);
        rightButton_.frame  = CGRectMake(633.5, 588.0, 168.0, 168.0);
        leftButton_.frame   = CGRectMake(-31.5, 588.0, 168.0, 168.0);
        pauseButton_.frame  = CGRectMake(-10.5, 420.0, 126.0, 126.0);
        
        // ポーズ時の画面設定
        pauseScrView_           = [[UIScrollView alloc] initWithFrame:CGRectMake(0.0,  0.0,   768.0, 1024.0)];
        pauseTitleImgView_      = [[UIImageView alloc] initWithFrame:CGRectMake(159.3, 126.0, 438.9, 180.6)];
        backButton_.frame       = CGRectMake(258.0, 420.0, 252.0, 72.45);
        helpButton_.frame       = CGRectMake(258.0, 588.0, 252.0, 72.45);
        
        // ヘルプ画面の設定
        helpScrView_                = [[UIScrollView alloc] initWithFrame:CGRectMake(0.0,  0.0,   768.0, 1024.0)];
        helpScrView_.contentSize    = CGSizeMake(768.0, 3072.0);
        helpScreenImgView1_         = [[UIImageView alloc] initWithFrame:CGRectMake(0.0,  0.0,    768.0, 1024.0)];
        helpScreenImgView2_         = [[UIImageView alloc] initWithFrame:CGRectMake(0.0,  1024.0, 768.0, 1024.0)];
        helpScreenImgView3_         = [[UIImageView alloc] initWithFrame:CGRectMake(0.0,  2048.0, 768.0, 1024.0)];
        helpScreenImgView1_.image   = [UIImage imageNamed:NSLocalizedString(@"help1_ipad.png", @"")];
        helpScreenImgView2_.image   = [UIImage imageNamed:NSLocalizedString(@"help2_ipad.png", @"")];
        helpScreenImgView3_.image   = [UIImage imageNamed:NSLocalizedString(@"help3_ipad.png", @"")];
        helpBackButton_.frame       = CGRectMake(0.0, 2992.0, 768.0, 80.0);
        [helpBackButton_ setImage:[UIImage imageNamed:@"btn_helpback_ipad.png"] forState:UIControlStateNormal];
        
        // アクションボードの設定
        boardImgView_           = [[UIImageView alloc] initWithFrame:CGRectMake(200.25, -651.0, 367.5, 651.0)];
        excellentTitleImgView_  = [[UIImageView alloc] initWithFrame:CGRectMake(48.0,   0.0,    672.0, 1008.0)];
        
        // 葉っぱの設定（x2.4）
        leafNormalImgView_  = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, -30.0,    768.0, 111.6)];
        leafMoreImgView_    = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, -190.8, 768.0, 190.8)];
        
        // ゲームスタート画面の設定
        gameStartTitleImgView_ = [[UIImageView alloc] initWithFrame:CGRectMake(176.1, 210.0, 415.8, 215.25)];
        
        // ゲームオーバー画面の設定
        gameOverScrView_        = [[UIScrollView alloc] initWithFrame:CGRectMake(0.0,  0.0,   768.0, 1024.0)];
        gameOverTitleImgView_   = [[UIImageView alloc] initWithFrame:CGRectMake(176.1, 210.0, 415.8, 215.25)];        
        tweetButton_.frame      = CGRectMake(258.0, 588.0, 252.0, 72.45);
        
        // Exitボタンの設定
        exitButton_.frame       = CGRectMake(258.0, 756.0, 252.0, 72.45);
        
        // ブロックのサイズ設定
        blockSize_ = kBlockSizeiPad;
    }
    
    //-- STEP3 --------------------//
    // サイズ以外の設定をします
    //-----------------------------//   
    // ルーレットの背景の設定
    rightRouletteImgView_.image = [UIImage imageNamed:@"bg_roulette.png"];
    rightShadowImgView_.image   = [UIImage imageNamed:@"dropshadow.png"];
    leftRouletteImgView_.image  = [UIImage imageNamed:@"bg_roulette.png"];
    leftShadowImgView_.image    = [UIImage imageNamed:@"dropshadow.png"];        
    
    // ルーレットの中身の設定（右側:キャラクター）        
    rightBlockImgView1_.image = [UIImage imageNamed:@"max.png"];
    rightBlockImgView2_.image = [UIImage imageNamed:@"leo.png"];
    rightBlockImgView3_.image = [UIImage imageNamed:@"netty.png"];
    rightBlockImgView4_.image = [UIImage imageNamed:@"pippo.png"];
    rightBlockImgView5_.image = [UIImage imageNamed:@"natch.png"];
    rightBlockImgView6_.image = [UIImage imageNamed:@"happy.png"];
    rightBlockImgView7_.image = [UIImage imageNamed:@"max.png"];
    
    // ルーレットの中身の設定（左側:倍率）      
    leftBlockImgView1_.image = [UIImage imageNamed:@"x2.png"];
    leftBlockImgView2_.image = [UIImage imageNamed:@"x3.png"];
    leftBlockImgView3_.image = [UIImage imageNamed:@"x4.png"];
    leftBlockImgView4_.image = [UIImage imageNamed:@"x2.png"];
    
    // ハイスコア表示欄の設定
    scoreImgView1_.image = [UIImage imageNamed:@"0.png"];
    scoreImgView2_.image = [UIImage imageNamed:@"0.png"];
    scoreImgView3_.image = [UIImage imageNamed:@"0.png"];
    scoreImgView4_.image = [UIImage imageNamed:@"0.png"];
    scoreImgView5_.image = [UIImage imageNamed:@"0.png"];
    scoreImgView6_.image = [UIImage imageNamed:@"0.png"];
    scoreImgView7_.image = [UIImage imageNamed:@"0.png"];
    scoreImgView8_.image = [UIImage imageNamed:@"0.png"];
    scoreImgView9_.image = [UIImage imageNamed:@"0.png"];
    
    // ゲームパッドの設定
    padScrView_.backgroundColor = [UIColor clearColor];
    padScrView_.alpha           = buttonAlpha;
    padScrView_.delegate        = self;
    
	[rotateButton_ setImage:[UIImage imageNamed:@"btn_turn_nomal.png"] forState:UIControlStateNormal];
	[rotateButton_ setImage:[UIImage imageNamed:@"btn_turn_down.png"] forState:UIControlStateHighlighted];
	[rotateButton_ addTarget:self action:@selector(rotateBlock) forControlEvents:UIControlEventTouchUpInside];
    
	[downButton_ setImage:[UIImage imageNamed:@"btn_speed_nomal.png"] forState:UIControlStateNormal];
	[downButton_ setImage:[UIImage imageNamed:@"btn_speed_down.png"] forState:UIControlStateHighlighted];
	[downButton_ addTarget:self action:@selector(dropBlock:) forControlEvents:UIControlEventTouchUpInside];
    
	[rightButton_ setImage:[UIImage imageNamed:@"btn_r_nomal.png"] forState:UIControlStateNormal];
	[rightButton_ setImage:[UIImage imageNamed:@"btn_r_down.png"] forState:UIControlStateHighlighted];
	[rightButton_ addTarget:self action:@selector(rightMove) forControlEvents:UIControlEventTouchUpInside];
    
	[leftButton_ setImage:[UIImage imageNamed:@"btn_l_nomal.png"] forState:UIControlStateNormal];
	[leftButton_ setImage:[UIImage imageNamed:@"btn_l_down.png"] forState:UIControlStateHighlighted];
	[leftButton_ addTarget:self action:@selector(leftMove) forControlEvents:UIControlEventTouchUpInside];
    
	[pauseButton_ setImage:[UIImage imageNamed:@"btn_pause_nomal.png"] forState:UIControlStateNormal];
	[pauseButton_ setImage:[UIImage imageNamed:@"btn_pause_down.png"] forState:UIControlStateHighlighted];
	[pauseButton_ addTarget:self action:@selector(gamePause) forControlEvents:UIControlEventTouchUpInside];
    
    // ポーズ時の画面設定
    pauseScrView_.backgroundColor = [UIColor blackColor];
    pauseScrView_.alpha = 0.7;
    pauseTitleImgView_.image = [UIImage imageNamed:@"pause.png"];
    
    [backButton_ setImage:[UIImage imageNamed:@"back.png"] forState:UIControlStateNormal];
    [backButton_ addTarget:self action:@selector(gameResume) forControlEvents:UIControlEventTouchUpInside];
    
    [helpButton_ setImage:[UIImage imageNamed:@"help.png"] forState:UIControlStateNormal];
    [helpButton_ addTarget:self action:@selector(showHelp) forControlEvents:UIControlEventTouchUpInside];
    
    // ヘルプ画面の設定
    helpScrView_.pagingEnabled  = YES;
    
    // 戻るボタンの設定（透明のボタン）
    [helpBackButton_ addTarget:self action:@selector(hideHelp) forControlEvents:UIControlEventTouchUpInside];
    
    // アクションボードの設定
    boardImgView_.image             = [UIImage imageNamed:@"game_speedup.png"];
    excellentTitleImgView_.image    = [UIImage imageNamed:NSLocalizedString(@"game_excellent.png", @"")];
    
    // 葉っぱの設定
    leafNormalImgView_.image    = [UIImage imageNamed:@"leaf_nomal.png"];
    leafMoreImgView_.image      = [UIImage imageNamed:@"leaf_more.png"];
    
    // ゲームスタート画面の設定
    gameStartTitleImgView_.image = [UIImage imageNamed:@"game_start.png"];
    
    // ゲームオーバー画面の設定
    gameOverScrView_.backgroundColor = [UIColor blackColor];
    gameOverScrView_.alpha = 0.7;
    gameOverTitleImgView_.image = [UIImage imageNamed:@"game_over.png"];
    
    // ボタンの設定
    [tweetButton_ setImage:[UIImage imageNamed:@"twitter.png"] forState:UIControlStateNormal];
    [tweetButton_ addTarget:self action:@selector(showTwitter) forControlEvents:UIControlEventTouchUpInside];
    
    // Exitボタンの設定
    exitButton_.alpha = 0.7;
    [exitButton_ setTitle:@"" forState: UIControlStateNormal];
    [exitButton_ setImage:[UIImage imageNamed:@"exit.png"] forState:UIControlStateNormal];
    [exitButton_ addTarget:self action:@selector(gameExit) forControlEvents:UIControlEventTouchUpInside];
    [exitButton_ removeFromSuperview]; // storyboardに設定しているボタンを非表示に
    
    //-- STEP4 --------------------//
    // 設定が完了した各種ビューをメインビューに配置します。
    //-----------------------------//
    [bgImgView_ addSubview:masuImgView_];
    
    [rightRouletteScrView_ addSubview:rightBlockImgView1_];
    [rightRouletteScrView_ addSubview:rightBlockImgView2_];
    [rightRouletteScrView_ addSubview:rightBlockImgView3_];
    [rightRouletteScrView_ addSubview:rightBlockImgView4_];
    [rightRouletteScrView_ addSubview:rightBlockImgView5_];
    [rightRouletteScrView_ addSubview:rightBlockImgView6_];
    [rightRouletteScrView_ addSubview:rightBlockImgView7_];
    
    [leftRouletteScrView_ addSubview:leftBlockImgView1_];
    [leftRouletteScrView_ addSubview:leftBlockImgView2_];
    [leftRouletteScrView_ addSubview:leftBlockImgView3_];
    [leftRouletteScrView_ addSubview:leftBlockImgView4_];
    
    [frameImgView_ addSubview:rightRouletteImgView_];
    [frameImgView_ addSubview:rightRouletteScrView_];
    [frameImgView_ addSubview:rightShadowImgView_];
    [frameImgView_ addSubview:leftRouletteImgView_];
    [frameImgView_ addSubview:leftRouletteScrView_];  
    [frameImgView_ addSubview:leftShadowImgView_];
    [frameImgView_ addSubview:frameImageImgView_];
    [frameImgView_ addSubview:scoreImgView1_];
    [frameImgView_ addSubview:scoreImgView2_];
    [frameImgView_ addSubview:scoreImgView3_];
    [frameImgView_ addSubview:scoreImgView4_];
    [frameImgView_ addSubview:scoreImgView5_];
    [frameImgView_ addSubview:scoreImgView6_];
    [frameImgView_ addSubview:scoreImgView7_];
    [frameImgView_ addSubview:scoreImgView8_];
    [frameImgView_ addSubview:scoreImgView9_];
    
    [padScrView_ addSubview:rightButton_];
    [padScrView_ addSubview:leftButton_];
    [padScrView_ addSubview:rotateButton_];
    [padScrView_ addSubview:downButton_];
    [padScrView_ addSubview:pauseButton_];
    
    [pauseScrView_ addSubview:pauseTitleImgView_];
    [pauseScrView_ addSubview:backButton_];
    [pauseScrView_ addSubview:helpButton_];
    
    [helpScrView_ addSubview:helpScreenImgView1_];
    [helpScrView_ addSubview:helpScreenImgView2_];
    [helpScrView_ addSubview:helpScreenImgView3_];
    [helpScrView_ addSubview:helpBackButton_];
    
    [gameOverScrView_ addSubview:gameOverTitleImgView_];
    
    [self.view addSubview:bgImgView_];
    [self.view addSubview:frameImgView_];
    [self.view addSubview:boardImgView_];
    [self.view addSubview:leafNormalImgView_];
    [self.view addSubview:leafMoreImgView_];
    
    //-- STEP5 --------------------//
    // 音楽の再生準備をします。
    //-----------------------------//
    // デフォルト音楽の場合
    if ([bgmTitle_ length] == 0) {        
        // 曲を選択（ランダム）
        // STEP1 乱数の初期化
        srand([[NSDate date] timeIntervalSinceReferenceDate]);
        
        // STEP2 乱数発生（0〜2までの値を出す）
        int val3 = rand()%3;
        
        // パスを選択
        NSString *pathNormal = @"";
        switch (val3) {
            case 0:
                pathNormal = [[NSBundle mainBundle] pathForResource:@"bgm_game_01" ofType:@"mp3"];
                break;
            case 1:
                pathNormal = [[NSBundle mainBundle] pathForResource:@"bgm_game_02" ofType:@"mp3"];
                break;    
            case 2:
                pathNormal = [[NSBundle mainBundle] pathForResource:@"bgm_game_03" ofType:@"mp3"];
                break;    
            default:
                break;
        }
        
        NSURL *urlNormal                = [NSURL fileURLWithPath:pathNormal];
        gameAudioNormal_                = [[AVAudioPlayer alloc] initWithContentsOfURL:urlNormal error:nil]; 
        gameAudioNormal_.currentTime    = 0.0;
        gameAudioNormal_.volume         = audioVolume_;
        gameAudioNormal_.numberOfLoops  = -1;
        
        // 再生準備
        [gameAudioNormal_ prepareToPlay];
        
    // iPod音楽の場合
    }else{
        // 曲を検索
        MPMediaQuery *query = [[MPMediaQuery alloc] init];
        [query addFilterPredicate: [MPMediaPropertyPredicate predicateWithValue:bgmTitle_ forProperty: MPMediaItemPropertyTitle]];
        
        // 条件に一致する曲を取得。配列の要素は MPMediaItem
        musicPlayer_ = [[MPMusicPlayerController alloc] init];
        // アプリケーション自身で音楽を再生する（ホームボタン押下時に曲を停止）
        musicPlayer_ = [MPMusicPlayerController applicationMusicPlayer];
        // 繰り返しの設定（1曲のみ）
        musicPlayer_.repeatMode = MPMusicRepeatModeOne;
        [musicPlayer_ setQueueWithQuery:query];
    }
    
    // パニック音の設定
    NSString *path                  = [[NSBundle mainBundle] pathForResource:@"bgm_game_panic" ofType:@"mp3"];
    NSURL *url                      = [NSURL fileURLWithPath:path];
    gameAudioPanic_                 = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:nil]; 
    gameAudioPanic_.currentTime     = 0.0;
    gameAudioPanic_.volume          = audioVolume_;
    gameAudioPanic_.numberOfLoops   = -1;
    
    // 再生準備
    [gameAudioPanic_ prepareToPlay];
    
    // 各種効果音の準備
    // 効果音準備（移動）
	NSString *path1 = [[NSBundle mainBundle] pathForResource:@"se_game_01" ofType:@"wav"];
	NSURL *url1 = [NSURL fileURLWithPath:path1];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url1, &gameSound1_);
    
    // 効果音準備（回転）
    NSString *path2 = [[NSBundle mainBundle] pathForResource:@"se_game_02" ofType:@"wav"];
	NSURL *url2 = [NSURL fileURLWithPath:path2];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url2, &gameSound2_);
    
    // 効果音準備（落下）    
    NSString *path3 = [[NSBundle mainBundle] pathForResource:@"se_game_03" ofType:@"wav"];
	NSURL *url3 = [NSURL fileURLWithPath:path3];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url3, &gameSound3_);
    
    // 効果音準備（消す）    
    NSString *path4 = [[NSBundle mainBundle] pathForResource:@"se_game_04" ofType:@"wav"];
	NSURL *url4 = [NSURL fileURLWithPath:path4];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url4, &gameSound4_);
    
    // 効果音準備（ゲームオーバー）    
    NSString *path5 = [[NSBundle mainBundle] pathForResource:@"se_game_05" ofType:@"wav"];
	NSURL *url5 = [NSURL fileURLWithPath:path5];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url5, &gameSound5_);
    
    // 効果音準備（進む）
	NSString *path6 = [[NSBundle mainBundle] pathForResource:@"se_select" ofType:@"wav"];
	NSURL *url6 = [NSURL fileURLWithPath:path6];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url6, &gameSound6_);
    
    // 効果音準備（戻る）
	NSString *path7 = [[NSBundle mainBundle] pathForResource:@"se_cancel" ofType:@"wav"];
	NSURL *url7 = [NSURL fileURLWithPath:path7];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url7, &gameSound7_);
    
    // 効果音準備（スペシャル消し）     
    NSString *path8 = [[NSBundle mainBundle] pathForResource:@"se_game_06" ofType:@"wav"];
	NSURL *url8 = [NSURL fileURLWithPath:path8];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url8, &gameSound8_);
    
    // 効果音準備（全消し）     
    NSString *path9 = [[NSBundle mainBundle] pathForResource:@"se_game_06" ofType:@"wav"];
	NSURL *url9 = [NSURL fileURLWithPath:path9];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url9, &gameSound9_);
    
    // 効果音準備（台風）     
    NSString *path10 = [[NSBundle mainBundle] pathForResource:@"se_game_07" ofType:@"wav"];
	NSURL *url10 = [NSURL fileURLWithPath:path10];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url10, &gameSound10_);
    
    // 効果音準備（クモの巣）     
    NSString *path11 = [[NSBundle mainBundle] pathForResource:@"se_game_08" ofType:@"wav"];
	NSURL *url11 = [NSURL fileURLWithPath:path11];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url11, &gameSound11_);
    
    // 効果音準備（ポーズ）     
    NSString *path12 = [[NSBundle mainBundle] pathForResource:@"se_game_10" ofType:@"wav"];
	NSURL *url12 = [NSURL fileURLWithPath:path12];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url12, &gameSound12_);
    
    // 効果音準備（得点UP）     
    NSString *path13 = [[NSBundle mainBundle] pathForResource:@"se_game_11" ofType:@"wav"];
	NSURL *url13 = [NSURL fileURLWithPath:path13];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url13, &gameSound13_);
    
    // 効果音準備（得点DOWN）     
    NSString *path14 = [[NSBundle mainBundle] pathForResource:@"se_game_12" ofType:@"wav"];
	NSURL *url14 = [NSURL fileURLWithPath:path14];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url14, &gameSound14_);
    
    // 効果音準備（スピードUP）     
    NSString *path15 = [[NSBundle mainBundle] pathForResource:@"se_game_13" ofType:@"wav"];
	NSURL *url15 = [NSURL fileURLWithPath:path15];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url15, &gameSound15_);
    
    // 効果音準備（スピードDOWN）     
    NSString *path16 = [[NSBundle mainBundle] pathForResource:@"se_game_14" ofType:@"wav"];
	NSURL *url16 = [NSURL fileURLWithPath:path16];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)url16, &gameSound16_);
    
    //-- STEP6 --------------------//
    // Twitterの状況をチェックします
    //-----------------------------// 
    // iOS5以降の場合にアカウント情報変更通知を受ける
    if([[[UIDevice currentDevice] systemVersion] floatValue] >= 5.0f)  {
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(checkTwitter) name:ACAccountStoreDidChangeNotification object:nil];
        [self performSelector:@selector(checkTwitter)];
    }
    
    //-- STEP7 --------------------//
    // 各種データを初期化します
    //-----------------------------//    
    // データ配列（1行目（一番下）は、処理の都合上「空白が停止している」状態とする）
    NSMutableArray *basicArray = [[NSMutableArray alloc] initWithObjects:@"00",@"00",@"00",@"00",@"00",@"00", nil];
    NSMutableArray *basicArray2 = [[NSMutableArray alloc] initWithObjects:@"09",@"09",@"09",@"09",@"09",@"09", nil];
    dataArray_ = [[NSMutableArray alloc] init];
    
    for (int i=0; i<10; i++) {
        [dataArray_ addObject:basicArray];
    }
    [dataArray_ addObject:basicArray2];
    
    // 難易度によるスピードの初期化
    switch (difficulty_) {
        case 0:
            speed_ = kSpeedEasy;
            break;
        case 1:
            speed_ = kSpeedMedium;
            break;
        case 2:
            speed_ = kSpeedHard;
            break;
        default:
            break;
    }
    
    // 変数の初期化
    scale_              = 1;
    score_              = 0;
    effectType_         = 0;
    
    downSkipFlg_        = NO;
    addSkipFlg_         = NO;
    effectSkipFlg_      = NO;
    rouletteSkipFlg_    = NO;
    allSkipFlg_         = NO;
    clearTrapFlg_       = NO;
    gameOverFlg_        = NO;
    
    clearCount_         = 0;    
    moveCount_          = 0;
    timerCount_         = 0;
    
    soundType_          = 0;
    
    // ルーレットの回転角度の初期化
    angleR_             = 0.0;
    angleL_             = 0.0;
    
    // 位置と速度を初期化
	posX_               = 0.0;
	posY_               = 0.0;
	vx_                 = 0.0;
	vy_                 = 0.0;
	
	// 加速度を初期化
	accelX_             = 0.0;
	accelY_             = 0.0;
	accelZ_             = 0.0;
    
    // 加速度センサーの設定
	UIAccelerometer *accelerometer = [UIAccelerometer sharedAccelerometer];
	accelerometer.updateInterval = 0.02;
	accelerometer.delegate = self;
    
    //-- STEP8 --------------------//
    // ブロックオブジェクトの準備をします
    //-----------------------------//
    blockArray_     = [[NSMutableArray alloc] init];
    blockArraySP_   = [[NSMutableArray alloc] init];    
    
    // iPhoneの場合
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        for (int i=0; i<11; i++) {
            for (int c=0; c<6; c++) {
                // ブロックの初期配置（通常）（微調整済み）
                UIImageView *blockImage = [[UIImageView alloc]initWithFrame:CGRectMake(((c+1)*blockSize_)+0.6, ((i+1)*blockSize_)-0.7, blockSize_, blockSize_)];
                [blockArray_ addObject:blockImage];
                [bgImgView_ addSubview:blockImage];
                
                // ブロックの初期配置（クモと台風）（微調整済み）
                UIImageView *blockImageSP = [[UIImageView alloc]initWithFrame:CGRectMake(((c+1)*blockSize_)+0.6, ((i+1)*blockSize_)-0.7, blockSize_, blockSize_)];
                [blockArraySP_ addObject:blockImageSP];
                [bgImgView_ addSubview:blockImageSP];
            }
        }
    // iPadの場合
    }else{
        for (int i=0; i<11; i++) {
            for (int c=0; c<6; c++) {
                // ブロックの初期配置（通常）（微調整済み）
                UIImageView *blockImage = [[UIImageView alloc]initWithFrame:CGRectMake(((c+1)*blockSize_)+49.0, ((i+1)*blockSize_)-1.2, blockSize_, blockSize_)];
                [blockArray_ addObject:blockImage];
                [bgImgView_ addSubview:blockImage];
                
                // ブロックの初期配置（クモと台風）（微調整済み）
                UIImageView *blockImageSP = [[UIImageView alloc]initWithFrame:CGRectMake(((c+1)*blockSize_)+49.0, ((i+1)*blockSize_)-1.2, blockSize_, blockSize_)];
                [blockArraySP_ addObject:blockImageSP];
                [bgImgView_ addSubview:blockImageSP];
            }
        }
    }
    
    //-- STEP9 --------------------//
    // 事前準備処理終了まで、ロード画面表示します
    //-----------------------------//
    [self gameStart];
}

#pragma mark -
#pragma mark M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//

#pragma mark -
#pragma mark M-5.1 ブロック動作についての各種処理
//------------------------------------------//
// M-5.1 ブロック動作についての各種処理
//------------------------------------------//

// ゲームスタート時の動きを設定します。
- (void)gameStart
{
    // ゲームスタート画面とゲームパッドを追加
    [self.view addSubview:padScrView_];
    [self.view addSubview:gameStartTitleImgView_];
    
    // 音楽の再生（デフォルト音楽oriPod音楽）
    if ([bgmTitle_ length] == 0) {
        [gameAudioNormal_ play];
    }else{
        [musicPlayer_ play];
    }
    
    // タイマーの設置
	gameTimer_ = [NSTimer scheduledTimerWithTimeInterval:kSpeedBase
                                                  target:self
                                                selector:@selector(gameControl)
                                                userInfo:nil
                                                 repeats:YES];
    
    // 1秒後に画面を引っ込める
    [self performSelector:@selector(startBoardHide) withObject:nil afterDelay:1];
}

// ここでゲーム全体を制御します。
// 呼び出しはタイマーから行います。
- (void)gameControl
{
    // ルーレットの制御
    if(!rouletteSkipFlg_){
        [self turnLeftRoulette];
        [self turnRightRoulette];
    }
    
    // ブロックの制御
    if(timerCount_ >= speed_){
        // カウンターのリセット
        timerCount_ = 0;
        
        // ブロックを落とす
        if(!allSkipFlg_){
            [self downBlock];
        }
    }
    timerCount_ += 1;    
}

// ゲーム中断時の動きを設定します。
- (void)gamePause
{
    // タイマーの停止
    [gameTimer_ invalidate];
    
    // ボリュームを下げる（iPodは行わない）
    gameAudioNormal_.volume = 0.1;
    gameAudioPanic_.volume  = 0.1;
    
    // ボタンの使用禁止
    rightButton_.enabled  = NO;
    leftButton_.enabled   = NO;
    rotateButton_.enabled = NO;
    downButton_.enabled   = NO;
    pauseButton_.enabled  = NO;
    
    // ポース画面の表示
    [self.view addSubview:pauseScrView_];
    [self.view addSubview:exitButton_];
    
    // 効果音の再生
    [self playSound:kSoundType12];
}

// ヘルプ画面の表示をします。
- (void)showHelp
{    
    // ヘルプ用ビューの表示
    [self.view addSubview:helpScrView_];
    
    // 効果音の再生
    [self playSound:kSoundType6];
}

// ヘルプ画面を非表示にします。
- (void)hideHelp
{
    // ヘルプ用ビューの表示
    [helpScrView_ removeFromSuperview];
    
    // 効果音の再生
    [self playSound:kSoundType7];
}

// ゲーム再開時の動きを設定します。
- (void)gameResume
{
    // ポーズ画面の非表示
    [pauseScrView_ removeFromSuperview];
    [exitButton_ removeFromSuperview];
    
    // ボタンの使用再開
    rightButton_.enabled  = YES;
    leftButton_.enabled   = YES;
    rotateButton_.enabled = YES;
    downButton_.enabled   = YES;
    pauseButton_.enabled  = YES;   
    
    // ボリュームを上げる（iPodは行わない）
    gameAudioNormal_.volume = audioVolume_;
    gameAudioPanic_.volume  = audioVolume_;
    
    // ゲームオーバーとタイミングが合った場合は処理を行わない
    if(!gameOverFlg_){
        
        // 落下処理用タイマー再開
        gameTimer_ = [NSTimer scheduledTimerWithTimeInterval:kSpeedBase
                                                      target:self
                                                    selector:@selector(gameControl)
                                                    userInfo:nil
                                                     repeats:YES];
    }
}

// ゲームオーバー時の動きを設定します。
- (void)gameOver
{
    // フラグをONに
    gameOverFlg_ = YES;
    
    // タイマーの停止
    [gameTimer_ invalidate];
    
    // ボタンの使用禁止
    rightButton_.enabled  = NO;
    leftButton_.enabled   = NO;
    rotateButton_.enabled = NO;
    downButton_.enabled   = NO;
    pauseButton_.enabled  = NO;  
    
    // ゲームオーバー画面の表示&タッチを有効に
    [self.view addSubview:gameOverScrView_];
    [self.view addSubview:exitButton_];
    
    // 環境設定読み出し&変数設定
    NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
    NSArray *scoreArray          = [userDefaults arrayForKey:@"rankingData"];
    NSMutableArray *emptyArray   = [[NSMutableArray alloc] init];
    NSInteger tempScore          = 0;
    NSInteger thisScore          = score_;
    
    // ゲームセンターへの送信
    [self submitScore:thisScore forCategory:kLeaderBoardID];
    
    // 配列の組み換え
    for (int i=0; i<20; i++) {
        // 配列上のスコアを取得
        tempScore = [[scoreArray objectAtIndex:i] intValue];
        // スコアを比較
        if(thisScore >= tempScore){
            // 配列に追加
            [emptyArray addObject:[NSNumber numberWithInt:thisScore]];
            // 比較するスコアを入れ替え
            thisScore = tempScore;
        }else{
            [emptyArray addObject:[NSNumber numberWithInt:tempScore]];
        }
    }
    
    // 環境設定への上書き
    [userDefaults setObject:emptyArray forKey:@"rankingData"];
    
    // 音楽を止めて初期化
    if ([gameAudioNormal_ isPlaying]) {
        [gameAudioNormal_ stop];    
        gameAudioNormal_.currentTime = 0.0;
    }
    if ([gameAudioPanic_ isPlaying]) {
        [gameAudioPanic_ stop];
        gameAudioPanic_.currentTime  = 0.0;
    }
    if([musicPlayer_ playbackState] != MPMusicPlaybackStateStopped){
        [musicPlayer_ stop];
    }
    
    // 効果音の再生
	[self playSound:kSoundType5];
}

// ゲーム終了時の動きを設定します。
- (void)gameExit
{
    // 音楽を止めて初期化
    if ([gameAudioNormal_ isPlaying]) {
        [gameAudioNormal_ stop];    
        gameAudioNormal_.currentTime = 0.0;
    }
    if ([gameAudioPanic_ isPlaying]) {
        [gameAudioPanic_ stop];
        gameAudioPanic_.currentTime  = 0.0;
    }
    if([musicPlayer_ playbackState] != MPMusicPlaybackStateStopped){
        [musicPlayer_ stop];
    }
    
    // 効果音の再生
    [self playSound:kSoundType6];
}

#pragma mark -
#pragma mark M-5.2 ボタン操作についての各種処理
//------------------------------------------//
// M-5.2 ボタン操作についての各種処理
//------------------------------------------//

// 右ボタンを押したときの動きを設定します。
- (void)rightMove
{
    // 落下処理のみスキップする
    downSkipFlg_ = YES;
    
    // メソッド内で使う変数の定義
    NSMutableArray *targetArray = [[NSMutableArray alloc] init];
    NSInteger activeCount       = 0;
    
    // 配列のチェック
    for (int i=0; i<[dataArray_ count]-1; i++) {
        // 全データの中から1行取得
        NSArray *blockArray = [dataArray_ objectAtIndex:i];
        
        // 取得した1行の中身をチェック
        for (int c=0; c<[blockArray count]-1; c++) {
            // フラグの2桁目（ブロックの状態）を取得する
            NSString *condString     = [[blockArray objectAtIndex:c] substringFromIndex:1];
            NSString *condStringNext = [[blockArray objectAtIndex:c+1]substringFromIndex:1];
            
            // もし状態が1（落下対象（親））か2（落下対象（子））ならばアクティブカウントと処理対象配列を増やす
            if([condString isEqualToString:@"1"] || [condString isEqualToString:@"2"]){
                if (![condStringNext isEqualToString:@"9"]) {
                    [targetArray addObject:[NSString stringWithFormat:@"%d%d",i,c]];
                    activeCount += 1;
                }
            }
        }
    }
    
    // どちらのブロックも停止していない場合
    if (activeCount == 2){
        // 処理対象配列の中身を入れ替える
        for (int p=[targetArray count]; p>0; p--) {
            NSInteger row             = [[[targetArray objectAtIndex:p-1] substringToIndex:1] intValue];
            NSInteger col             = [[[targetArray objectAtIndex:p-1] substringFromIndex:1] intValue];                
            NSMutableArray *moveArray = [dataArray_ objectAtIndex:row];
            
            // クモの巣対応
            NSString *charString     = [[moveArray objectAtIndex:col] substringToIndex:1];
            NSString *condStringNext = [[moveArray objectAtIndex:col+1] substringFromIndex:1];
            if ([condStringNext isEqualToString:@"3"]) {
                NSString *tempString = [NSString stringWithFormat:@"%@3",charString];
                [moveArray replaceObjectAtIndex:col+1 withObject:tempString];
            }else{
                [moveArray replaceObjectAtIndex:col+1 withObject:[moveArray objectAtIndex:col]];
            }                
            [moveArray replaceObjectAtIndex:col withObject:@"00"];
        }
        // 効果音の再生
        [self playSound:kSoundType1];
    }
}

// 左ボタンを押したときの動きを設定します。
- (void)leftMove
{
    // 落下処理のみスキップする
    downSkipFlg_ = YES;
    
    // メソッド内で使う変数の定義
    NSMutableArray *targetArray = [[NSMutableArray alloc] init];
    NSInteger activeCount       = 0;
    
    // 配列のチェック
    for (int i=0; i<[dataArray_ count]-1; i++) {
        // 全データの中から1行取得
        NSArray *blockArray = [dataArray_ objectAtIndex:i]; 
        
        // 取得した1行の中身をチェック
        for (int c=1; c<[blockArray count]; c++) {
            // フラグの2桁目（ブロックの状態）を取得する
            NSString *condString     = [[blockArray objectAtIndex:c]substringFromIndex:1];
            NSString *condStringPrev = [[blockArray objectAtIndex:c-1]substringFromIndex:1];
            
            // もし状態が1（落下対象（親））か2（落下対象（子））ならばアクティブカウントと処理対象配列を増やす
            if([condString isEqualToString:@"1"] || [condString isEqualToString:@"2"]){
                if (![condStringPrev isEqualToString:@"9"]) {
                    [targetArray addObject:[NSString stringWithFormat:@"%d%d",i,c]];
                    activeCount += 1;
                }
            }
        }
    }
    
    // どちらのブロックも停止していない場合
    if (activeCount == 2){
        // 処理対象配列の中身を入れ替える
        for (int p=0; p<[targetArray count]; p++) {
            NSInteger row             = [[[targetArray objectAtIndex:p] substringToIndex:1]intValue];
            NSInteger col             = [[[targetArray objectAtIndex:p] substringFromIndex:1]intValue];                
            NSMutableArray *moveArray = [dataArray_ objectAtIndex:row];
            
            // クモの巣対応
            NSString *charString     = [[moveArray objectAtIndex:col] substringToIndex:1];
            NSString *condStringPrev = [[moveArray objectAtIndex:col-1] substringFromIndex:1];
            
            if ([condStringPrev isEqualToString:@"3"]) {
                NSString *tempString = [NSString stringWithFormat:@"%@3",charString];
                [moveArray replaceObjectAtIndex:col-1 withObject:tempString];
            }else{
                [moveArray replaceObjectAtIndex:col-1 withObject:[moveArray objectAtIndex:col]];
            }                
            [moveArray replaceObjectAtIndex:col withObject:@"00"];
        }
        // 効果音の再生
        [self playSound:kSoundType1];
    }
}

// 回転ボタンを押したときの動きを設定します。
- (void)rotateBlock
{
    // 落下処理のみスキップする
    downSkipFlg_ = YES;
    
    // メソッド内で使う変数の定義
    NSMutableArray *blockArray1st = [[NSMutableArray alloc] init];    
    NSMutableArray *blockArray2nd = [[NSMutableArray alloc] init];
    NSMutableArray *blockArray3rd = [[NSMutableArray alloc] init];
    NSMutableArray *blockArray09  = [[NSMutableArray alloc]initWithObjects:@"09",@"09",@"09",@"09",@"09",@"09",nil];
    
    NSInteger      blockPos1      = 0;
    NSInteger      blockPos2      = 0;
    NSInteger      blockArrayPos  = 0;
    
    NSString       *tempBlock     = @"";
    NSInteger      activeCount    = 0;
    
    // 回転が可能な状態かチェック（一番下の行を除く）
    for (int i=[dataArray_ count]-1; i>0; i--) {
        // 各行を取得
        NSMutableArray *blockArray = [dataArray_ objectAtIndex:i-1];
        
        // 1行を調べる
        for (int c=0; c<[blockArray count]; c++) {
            // 状態チェック
            NSString *condString = [[blockArray objectAtIndex:c]substringFromIndex:1];    
            // 親が落下状態であること
            if([condString isEqualToString:@"1"]){
                if(i == 1){
                    blockArray1st = blockArray09;
                }else{
                    blockArray1st = [dataArray_ objectAtIndex:i-2];
                }
                blockArray2nd = blockArray;
                blockArray3rd = [dataArray_ objectAtIndex:i];
                blockPos1 = c;
                activeCount += 1;
                // 子が落下状態であること
            }else if([condString isEqualToString:@"2"]){
                tempBlock = [blockArray objectAtIndex:c];
                activeCount += 1;
            }
        }
    }
    
    // 回転が可能な場合
    if (activeCount >= 2){
        // 子の場所確定
        NSString *condStringPos = @"";
        
        // 親が下、子が上
        for (int c=0; c<[blockArray1st count]; c++) {
            condStringPos = [[blockArray1st objectAtIndex:c]substringFromIndex:1];
            if ([condStringPos isEqualToString:@"2"]) {
                blockArrayPos = 1;
                blockPos2 = c;
            }
        }
        // 親子の関係が横並び
        for (int c=0; c<[blockArray2nd count]; c++) {
            condStringPos = [[blockArray2nd objectAtIndex:c]substringFromIndex:1];
            if ([condStringPos isEqualToString:@"2"]) {
                blockArrayPos = 2;
                blockPos2 = c;
            }
        }
        // 親が上、子が下
        for (int c=0; c<[blockArray3rd count]; c++) {
            condStringPos = [[blockArray3rd objectAtIndex:c]substringFromIndex:1];
            if ([condStringPos isEqualToString:@"2"]) {
                blockArrayPos = 3;
                blockPos2 = c;
            }
        }
        
        // 移動先の状態チェック&移動
        NSString *condStringNext = @"";
        
        // 子が上にあって、右に回ろうとしている
        if (blockArrayPos == 1) {
            if ((blockPos2+1) < 6) {
                condStringNext = [[blockArray2nd objectAtIndex:blockPos2+1]substringFromIndex:1];
                if ([condStringNext isEqualToString:@"0"]){
                    // 入れ替え
                    [blockArray1st replaceObjectAtIndex:blockPos2 withObject:@"00"];
                    [blockArray2nd replaceObjectAtIndex:blockPos2+1 withObject:tempBlock];
                    // 効果音の再生
                    [self playSound:kSoundType2];
                }
            }
            // 親子が横並びの場合
        }else if (blockArrayPos == 2) {
            // 子が右にあって、下に回ろうとしている
            if (blockPos1 < blockPos2) {
                condStringNext = [[blockArray3rd objectAtIndex:blockPos2-1]substringFromIndex:1];
                if ([condStringNext isEqualToString:@"0"]){
                    // 入れ替え
                    [blockArray2nd replaceObjectAtIndex:blockPos2 withObject:@"00"];
                    [blockArray3rd replaceObjectAtIndex:blockPos2-1 withObject:tempBlock];
                    // 効果音の再生
                    [self playSound:kSoundType2];
                }
                // 子が左にあって、上に回ろうとしている
            }else{
                condStringNext = [[blockArray1st objectAtIndex:blockPos2+1]substringFromIndex:1];
                if ([condStringNext isEqualToString:@"0"]){
                    // 入れ替え
                    [blockArray2nd replaceObjectAtIndex:blockPos2 withObject:@"00"];
                    [blockArray1st replaceObjectAtIndex:blockPos2+1 withObject:tempBlock];
                    // 効果音の再生
                    [self playSound:kSoundType2];
                }
            }
            // 子が下にあって、左に回ろうとしている
        }else if (blockArrayPos == 3) {
            if ((blockPos2-1) >= 0) {
                condStringNext = [[blockArray2nd objectAtIndex:blockPos2-1]substringFromIndex:1];
                if ([condStringNext isEqualToString:@"0"]){
                    // 入れ替え
                    [blockArray3rd replaceObjectAtIndex:blockPos2 withObject:@"00"];
                    [blockArray2nd replaceObjectAtIndex:blockPos2-1 withObject:tempBlock];
                    // 効果音の再生
                    [self playSound:kSoundType2];
                }
            }
        }
    }
}

// 落下ボタンを押したときの動きを設定します。
- (void)dropBlock:(id)sender
{
    // 処理可能である間は処理を繰り返す
    BOOL next = YES;
    while (next) {
        next = [self downBlock];
    }
    
    // 効果音の再生
    if(sender){
        [self playSound:kSoundType3];
    }
}

#pragma mark -
#pragma mark M-5.3 ブロック動作についての各種処理
//------------------------------------------//
// M-5.3 ブロック動作についての各種処理
//------------------------------------------//

// ブロックの自由落下の設定をします。
- (BOOL)downBlock
{    
    // スキップされていなければ落下させる
    if (!downSkipFlg_) {
        //　チェック用カウンターリセット
        moveCount_ = 0;
        
        // 下に落とす
        for (int i=[dataArray_ count]-1; i>0; i--) {
            
            // 現在の配列（上段下段）
            NSMutableArray *blockArrayUpper = [dataArray_ objectAtIndex:i-1];
            NSMutableArray *blockArrayLower = [dataArray_ objectAtIndex:i];
            
            // 差し替え対象の配列（カラ）
            NSMutableArray *emptyArrayUpper = [[NSMutableArray alloc]initWithObjects:@"00",@"00",@"00",@"00",@"00",@"00",nil];
            NSMutableArray *emptyArrayLower = [[NSMutableArray alloc]initWithObjects:@"00",@"00",@"00",@"00",@"00",@"00",nil];
            
            // 2段分チェック
            for (int c=0; c<[blockArrayUpper count]; c++) {
                NSString *charUpper = [[blockArrayUpper objectAtIndex:c]substringToIndex:1];
                NSString *condUpper = [[blockArrayUpper objectAtIndex:c]substringFromIndex:1];
                NSString *charLower = [[blockArrayLower objectAtIndex:c]substringToIndex:1];
                NSString *condLower = [[blockArrayLower objectAtIndex:c]substringFromIndex:1];
                
                // 下が空白で、落下できる場合
                if(([condUpper isEqualToString:@"1"] && [condLower isEqualToString:@"0"]) || ([condUpper isEqualToString:@"2"] && [condLower isEqualToString:@"0"])){
                    [emptyArrayUpper replaceObjectAtIndex:c withObject:[NSString stringWithFormat:@"00"]];
                    [emptyArrayLower replaceObjectAtIndex:c withObject:[NSString stringWithFormat:@"%@%@",charUpper,condUpper]];
                    moveCount_ += 1;
                    // 消したことによって下が空白になり、落下できる場合
                }else if(([condUpper isEqualToString:@"9"] && [condLower isEqualToString:@"0"]) || ([condUpper isEqualToString:@"9"] && [condLower isEqualToString:@"0"])){
                    [emptyArrayUpper replaceObjectAtIndex:c withObject:[NSString stringWithFormat:@"00"]];
                    [emptyArrayLower replaceObjectAtIndex:c withObject:[NSString stringWithFormat:@"%@%@",charUpper,condUpper]];                    
                    moveCount_ += 1;
                    // 下が停止で、落下できない場合
                }else if(([condUpper isEqualToString:@"1"] && [condLower isEqualToString:@"9"]) || ([condUpper isEqualToString:@"2"] && [condLower isEqualToString:@"9"])){
                    [emptyArrayUpper replaceObjectAtIndex:c withObject:[NSString stringWithFormat:@"%@9",charUpper]];
                    [emptyArrayLower replaceObjectAtIndex:c withObject:[NSString stringWithFormat:@"%@9",charLower]];
                    moveCount_ += 1;
                    // 下がクモの巣の場合
                }else if(([condUpper isEqualToString:@"1"] && [condLower isEqualToString:@"3"]) || ([condUpper isEqualToString:@"2"] && [condLower isEqualToString:@"3"])){
                    // 引っかかっているブロックなし
                    if ([charLower isEqualToString:@"0"]){
                        [emptyArrayUpper replaceObjectAtIndex:c withObject:[NSString stringWithFormat:@"00"]];
                        [emptyArrayLower replaceObjectAtIndex:c withObject:[NSString stringWithFormat:@"%@3",charUpper]];                        
                        // 引っかかっているブロックあり
                    }else{
                        [emptyArrayUpper replaceObjectAtIndex:c withObject:[NSString stringWithFormat:@"%@9",charUpper]];
                        [emptyArrayLower replaceObjectAtIndex:c withObject:[NSString stringWithFormat:@"%@3",charLower]];
                    }
                    moveCount_ += 1;
                    // それ以外の場合（つまり、そのまま動かない）
                }else{
                    [emptyArrayUpper replaceObjectAtIndex:c withObject:[NSString stringWithFormat:@"%@%@",charUpper,condUpper]];
                    [emptyArrayLower replaceObjectAtIndex:c withObject:[NSString stringWithFormat:@"%@%@",charLower,condLower]];
                }
            }
            // 配列の入れ替え
            [dataArray_ replaceObjectAtIndex:i-1 withObject:emptyArrayUpper];
            [dataArray_ replaceObjectAtIndex:i   withObject:emptyArrayLower];
        }
    }
    
    // 落下可能なブロックがなくなり、空白チェック状態でなければ
    if (moveCount_ == 0){
        // 消しをチェック
        [self checkBlock];
    }else{
        // オブジェクトの表示
        [self dispBlock];        
    }
    
    // スキップ解除
    downSkipFlg_ = NO;
    
    // 処理チェック
    if (moveCount_ == 0){
        return NO;
    }else{
        return YES;
    }
}

// ブロックの状態をチェックします。
- (void)checkBlock
{
    BOOL delFlg     = NO;
    BOOL allFlg     = NO;
    BOOL changeFlg1 = NO;
    BOOL changeFlg2 = NO;
    BOOL specialFlg = NO;
    
    // 1回のチェックでカウントした得点対象の回数
    NSInteger scoreCount = 0;
    
    // 全キャラ揃いチェック
    for (int i=0; i<[dataArray_ count]-1; i++) {
        // 全消し後かどうかのチェック（全消ししているのであれば、処理スキップ）
        if(!allFlg){
            // 全キャラ揃いチェック        
            NSMutableArray *blockHorArray = [dataArray_ objectAtIndex:i];
            
            // 1行のキャラクターを個別の変数に格納
            NSString *charString0 = [[blockHorArray objectAtIndex:0] substringToIndex:1];
            NSString *charString1 = [[blockHorArray objectAtIndex:1] substringToIndex:1];
            NSString *charString2 = [[blockHorArray objectAtIndex:2] substringToIndex:1];       
            NSString *charString3 = [[blockHorArray objectAtIndex:3] substringToIndex:1];
            NSString *charString4 = [[blockHorArray objectAtIndex:4] substringToIndex:1];
            NSString *charString5 = [[blockHorArray objectAtIndex:5] substringToIndex:1];
            
            // 配列に格納
            NSMutableArray *tempBlockArray = [[NSMutableArray alloc] initWithObjects:charString0,charString1,charString2,charString3,charString4,charString5, nil];
            
            // 変数の初期化
            NSString *charStringA = @"";
            
            // 数字の補正
            for (int j=0; j<[tempBlockArray count]; j++) {
                charStringA = [tempBlockArray objectAtIndex:j];
                // （マイキーSPをマイキーに）
                if([charStringA isEqualToString:@"7"]){
                    charStringA = @"1";
                    [tempBlockArray replaceObjectAtIndex:j withObject:charStringA];
                    // 数字の補正（サリーSPをサリーに）
                }else if([charStringA isEqualToString:@"8"]){
                    charStringA = @"2";
                    [tempBlockArray replaceObjectAtIndex:j withObject:charStringA];
                    // 数字の補正（消しインジケーターを空白扱いに）
                }else if([charStringA isEqualToString:@"9"]){
                    charStringA = @"0";
                    [tempBlockArray replaceObjectAtIndex:j withObject:charStringA];
                }
            }
            
            // 変数の初期化
            NSString *checkStringA = @"";
            NSString *checkStringB = @"";
            BOOL checkResult      = YES;
            
            // 配列分処理を実行
            for (int p=0; p<[tempBlockArray count]; p++) {
                checkStringA = [tempBlockArray objectAtIndex:p];
                
                // 空白等の場合は処理を終わらせる
                if ([checkStringA isEqualToString:@"0"]) {
                    checkResult = NO;
                }else{
                    // 自分と同じブロックがいるかどうかのチェック
                    for (int q=0; q<p; q++) {
                        checkStringB = [tempBlockArray objectAtIndex:q];
                        // 同じかどうかの比較
                        if ([checkStringA isEqualToString:checkStringB]) {
                            checkResult = NO;
                        }
                    }
                }
            }
            
            // 全キャラぞろいがあった場合
            if(checkResult){
                // フラグの一括処理（キャラクターを消しインジケーターに）
                for (int i=0; i<[dataArray_ count]-1; i++) {
                    NSMutableArray *blockArray = [dataArray_ objectAtIndex:i];
                    
                    for (int p=0; p<[blockArray count]; p++) {
                        NSString *condString = [[blockArray objectAtIndex:p] substringFromIndex:1];
                        
                        // 空白以外のセルすべて
                        if(![condString isEqualToString:@"0"]){
                            [blockArray replaceObjectAtIndex:p withObject:[NSString stringWithFormat:@"98"]];
                        }
                    }
                }
                // 削除フラグON
                delFlg = YES;
                // 全消しフラグON
                allFlg = YES;
                // 全消しの得点の加算（難易度によって得点が変わる）
                scoreCount += kCountExcellent;
                
                // ない場合は通常のチェック処理へ
            }else{
                
                // 横方向へのチェック
                for (int i=0; i<[dataArray_ count]-1; i++) {
                    
                    // 3つずつ絵柄をチェックする
                    for (int c=0; c<[blockHorArray count]-2; c++) {
                        NSString *charLeft   = [[blockHorArray objectAtIndex:c]   substringToIndex:1];
                        NSString *charCenter = [[blockHorArray objectAtIndex:c+1] substringToIndex:1];
                        NSString *charRight  = [[blockHorArray objectAtIndex:c+2] substringToIndex:1];
                        
                        // スペシャルブロックを変換（マイキーSPをマイキーに）
                        if([charLeft isEqualToString:@"7"]){
                            charLeft   = @"1";
                            changeFlg1 = YES;
                        }
                        if([charCenter isEqualToString:@"7"]){
                            charCenter = @"1";
                            changeFlg1 = YES;
                        }
                        if([charRight isEqualToString:@"7"]){
                            charRight  = @"1";
                            changeFlg1 = YES;
                        }
                        
                        // スペシャルブロックを変換（サリーSPをサリーに）
                        if([charLeft isEqualToString:@"8"]){
                            charLeft  = @"2";
                            changeFlg2 = YES;
                        }
                        if([charCenter isEqualToString:@"8"]){
                            charCenter = @"2";
                            changeFlg2 = YES;
                        }
                        if([charRight isEqualToString:@"8"]){
                            charRight  = @"2";
                            changeFlg2 = YES;
                        }
                        
                        // 3つ同じ柄が並んだ場合
                        if ([charLeft isEqualToString:charCenter] && [charCenter isEqualToString:charRight]) {
                            // マイキー
                            if([charLeft isEqualToString:@"1"]) {
                                // 配列の入れ替え（この段階では次があるのでキャラクターは変えない）
                                [blockHorArray replaceObjectAtIndex:c   withObject:@"18"];
                                [blockHorArray replaceObjectAtIndex:c+1 withObject:@"18"];
                                [blockHorArray replaceObjectAtIndex:c+2 withObject:@"18"];
                                // SPブロックが含まれていれば、SPフラグON
                                if(changeFlg1){
                                    specialFlg = YES;
                                }
                                // 削除フラグON
                                delFlg = YES;
                                // 得点の加算（難易度によって得点が変わる）
                                scoreCount += 1;
                                // サリー
                            }else if([charLeft isEqualToString:@"2"]) {
                                // 配列の入れ替え（この段階では次があるのでキャラクターは変えない）
                                [blockHorArray replaceObjectAtIndex:c   withObject:@"28"];
                                [blockHorArray replaceObjectAtIndex:c+1 withObject:@"28"];
                                [blockHorArray replaceObjectAtIndex:c+2 withObject:@"28"];                    
                                // SPブロックが含まれていれば、SPフラグON
                                if(changeFlg2){
                                    specialFlg = YES;
                                }
                                // 削除フラグON
                                delFlg = YES;
                                // 得点の加算（難易度によって得点が変わる）
                                scoreCount += 1;
                                // マックス
                            }else if([charLeft isEqualToString:@"3"]) {
                                // 配列の入れ替え（この段階では次があるのでキャラクターは変えない）
                                [blockHorArray replaceObjectAtIndex:c   withObject:@"38"];
                                [blockHorArray replaceObjectAtIndex:c+1 withObject:@"38"];
                                [blockHorArray replaceObjectAtIndex:c+2 withObject:@"38"]; 
                                // 削除フラグON
                                delFlg = YES;
                                // 得点の加算（難易度によって得点が変わる）
                                scoreCount += 1;
                                // ピッポ
                            }else if([charLeft isEqualToString:@"4"]) {
                                // 配列の入れ替え（この段階では次があるのでキャラクターは変えない）
                                [blockHorArray replaceObjectAtIndex:c   withObject:@"48"];
                                [blockHorArray replaceObjectAtIndex:c+1 withObject:@"48"];
                                [blockHorArray replaceObjectAtIndex:c+2 withObject:@"48"];
                                // 削除フラグON
                                delFlg = YES;
                                // 得点の加算（難易度によって得点が変わる）
                                scoreCount += 1;
                                // レオ
                            }else if([charLeft isEqualToString:@"5"]) {
                                // 配列の入れ替え（この段階では次があるのでキャラクターは変えない）
                                [blockHorArray replaceObjectAtIndex:c   withObject:@"58"];
                                [blockHorArray replaceObjectAtIndex:c+1 withObject:@"58"];
                                [blockHorArray replaceObjectAtIndex:c+2 withObject:@"58"];
                                // 削除フラグON
                                delFlg = YES;
                                // 得点の加算（難易度によって得点が変わる）
                                scoreCount += 1;
                                // ナッチ
                            }else if([charLeft isEqualToString:@"6"]) {
                                // 配列の入れ替え（この段階では次があるのでキャラクターは変えない）
                                [blockHorArray replaceObjectAtIndex:c   withObject:@"68"];
                                [blockHorArray replaceObjectAtIndex:c+1 withObject:@"68"];
                                [blockHorArray replaceObjectAtIndex:c+2 withObject:@"68"]; 
                                // 削除フラグON
                                delFlg = YES;
                                // 得点の加算（難易度によって得点が変わる）
                                scoreCount += 1;
                            }
                        }
                        
                        // フラグの初期化
                        changeFlg1 = NO;
                        changeFlg2 = NO;
                    }
                }
                
                // 縦方向へのチェック
                for (int i=0; i<6; i++) {
                    
                    // 配列を縦に
                    NSMutableArray *blockVerArray = [[NSMutableArray alloc] init];
                    
                    for (int p=0; p<[dataArray_ count]-1; p++) {
                        [blockVerArray addObject:[[dataArray_ objectAtIndex:p] objectAtIndex:i]];
                    }
                    
                    // 3つずつ絵柄をチェックする
                    for (int c=0; c<[blockVerArray count]-2; c++) {
                        
                        NSString *charLower  = [[blockVerArray objectAtIndex:c] substringToIndex:1];
                        NSString *charMiddle = [[blockVerArray objectAtIndex:c+1] substringToIndex:1];
                        NSString *charUpper  = [[blockVerArray objectAtIndex:c+2] substringToIndex:1];
                        
                        // スペシャルブロックを変換（マイキーSPをマイキーに）
                        if([charLower isEqualToString:@"7"]){
                            charLower  = @"1";
                            changeFlg1 = YES;
                        }
                        if([charMiddle isEqualToString:@"7"]){
                            charMiddle = @"1";
                            changeFlg1 = YES;
                        }
                        if([charUpper isEqualToString:@"7"]){
                            charUpper  = @"1";
                            changeFlg1 = YES;
                        }
                        
                        // スペシャルブロックを変換（サリーSPをサリーに）
                        if([charLower isEqualToString:@"8"]){
                            charLower  = @"2";
                            changeFlg2 = YES;
                        }
                        if([charMiddle isEqualToString:@"8"]){
                            charMiddle = @"2";
                            changeFlg2 = YES;
                        }
                        if([charUpper isEqualToString:@"8"]){
                            charUpper  = @"2";
                            changeFlg2 = YES;
                        }
                        
                        // 3つ同じ柄が並んだ場合
                        if ([charLower isEqualToString:charMiddle] && [charMiddle isEqualToString:charUpper]) {
                            // マイキー
                            if([charLower isEqualToString:@"1"]) {
                                // 配列の入れ替え（この段階では次があるのでキャラクターは変えない）
                                [blockVerArray replaceObjectAtIndex:c   withObject:@"18"];
                                [blockVerArray replaceObjectAtIndex:c+1 withObject:@"18"];
                                [blockVerArray replaceObjectAtIndex:c+2 withObject:@"18"];
                                // SPブロックが含まれていれば、SPフラグON
                                if(changeFlg1){
                                    specialFlg = YES;
                                }
                                // 削除フラグON
                                delFlg = YES;
                                // 得点の加算（難易度によって得点が変わる）
                                scoreCount += 1;
                                // サリー
                            }else if([charLower isEqualToString:@"2"]) {
                                // 配列の入れ替え（この段階では次があるのでキャラクターは変えない）
                                [blockVerArray replaceObjectAtIndex:c   withObject:@"28"];
                                [blockVerArray replaceObjectAtIndex:c+1 withObject:@"28"];
                                [blockVerArray replaceObjectAtIndex:c+2 withObject:@"28"];                    
                                // SPブロックが含まれていれば、SPフラグON
                                if(changeFlg2){
                                    specialFlg = YES;
                                }
                                // 削除フラグON
                                delFlg = YES;
                                // 得点の加算（難易度によって得点が変わる）
                                scoreCount += 1;
                                // マックス
                            }else if([charLower isEqualToString:@"3"]) {
                                // 配列の入れ替え（この段階では次があるのでキャラクターは変えない）
                                [blockVerArray replaceObjectAtIndex:c   withObject:@"38"];
                                [blockVerArray replaceObjectAtIndex:c+1 withObject:@"38"];
                                [blockVerArray replaceObjectAtIndex:c+2 withObject:@"38"];
                                // 削除フラグON
                                delFlg = YES;
                                // 得点の加算（難易度によって得点が変わる）
                                scoreCount += 1;
                                // ピッポ
                            }else if([charLower isEqualToString:@"4"]) {
                                // 配列の入れ替え（この段階では次があるのでキャラクターは変えない）
                                [blockVerArray replaceObjectAtIndex:c   withObject:@"48"];
                                [blockVerArray replaceObjectAtIndex:c+1 withObject:@"48"];
                                [blockVerArray replaceObjectAtIndex:c+2 withObject:@"48"];
                                // 削除フラグON
                                delFlg = YES;
                                // 得点の加算（難易度によって得点が変わる）
                                scoreCount += 1;
                                // レオ
                            }else if([charLower isEqualToString:@"5"]) {
                                // 配列の入れ替え（この段階では次があるのでキャラクターは変えない）
                                [blockVerArray replaceObjectAtIndex:c   withObject:@"58"];
                                [blockVerArray replaceObjectAtIndex:c+1 withObject:@"58"];
                                [blockVerArray replaceObjectAtIndex:c+2 withObject:@"58"];
                                // 削除フラグON
                                delFlg = YES;
                                // 得点の加算（難易度によって得点が変わる）
                                scoreCount += 1;
                                // ナッチ
                            }else if([charLower isEqualToString:@"6"]) {
                                // 配列の入れ替え（この段階では次があるのでキャラクターは変えない）
                                [blockVerArray replaceObjectAtIndex:c   withObject:@"68"];
                                [blockVerArray replaceObjectAtIndex:c+1 withObject:@"68"];
                                [blockVerArray replaceObjectAtIndex:c+2 withObject:@"68"];
                                // 削除フラグON
                                delFlg = YES;
                                // 得点の加算（難易度によって得点が変わる）
                                scoreCount += 1;
                            }
                        }
                        
                        // フラグの初期化
                        changeFlg1 = NO;
                        changeFlg2 = NO;
                    }
                    
                    // 配列を横に
                    for (int r=0; r<[dataArray_ count]-1; r++) {
                        blockHorArray = [dataArray_ objectAtIndex:r];
                        [blockHorArray replaceObjectAtIndex:i withObject:[blockVerArray objectAtIndex:r]];
                    }
                }
            }
        }
    }
    
    // フラグの一括処理（キャラクターを消しインジケーターに）
    for (int i=0; i<[dataArray_ count]-1; i++) {
        NSMutableArray *blockArray = [dataArray_ objectAtIndex:i];
        
        for (int p=0; p<[blockArray count]; p++) {
            NSString *condString = [[blockArray objectAtIndex:p]substringFromIndex:1];
            
            if([condString isEqualToString:@"8"]){
                [blockArray replaceObjectAtIndex:p withObject:[NSString stringWithFormat:@"98"]];
            }
        }
    }
    
    // 消しインジケーターを表示
    [self dispBlock];
    
    // 難易度によるスコアアップ
    switch (difficulty_) {
        case 0:
            score_ += scoreCount * kScoreEasy;
            break;
        case 1:
            score_ += scoreCount * kScoreMedium;
            break;
        case 2:
            score_ += scoreCount * kScoreHard;
            break;
        case 3:
            score_ += scoreCount * kScoreVeryHard;
            break;
        case 4:
            score_ += scoreCount * kScoreExtreme;
            break;
        default:
            break;
    }
    
    // 音楽の切り替え（上から4列目以上にブロックがあった場合）
    NSInteger panicCount = 0;
    for (int p=0; p<4; p++) {        
        NSMutableArray *blockArray = [dataArray_ objectAtIndex:p];
        
        for (int c=0; c<[blockArray count]; c++) {
            NSString *condString = [[blockArray objectAtIndex:c]substringFromIndex:1];            
            if([condString isEqualToString:@"9"]){
                panicCount += 1;
            }
        }
    }
    
    // 1個でも危険ゾーンにブロックがあった場合
    if (panicCount > 0){
        // 音楽切り替え（デフォルト音楽のみ）
        if ([gameAudioNormal_ isPlaying]) {
            [gameAudioNormal_ stop];    
            gameAudioNormal_.currentTime = 0.0;
            
            [gameAudioPanic_ play];
        }
    }else{
        // 音楽切り替え（デフォルト音楽のみ）
        if ([gameAudioPanic_ isPlaying]) {
            [gameAudioPanic_ stop];
            gameAudioPanic_.currentTime  = 0.0;
            
            [gameAudioNormal_ play];
        }
    }
    
    // 結果ステータス
    if (delFlg) { 
        if(allFlg){
            // 全消し画面の表示
            [self excellentShow];
            
        }else if (specialFlg && !effectSkipFlg_) {
            //-- スペシャル消しについて ----------------------------//
            // レインボーブロックが含まれていた場合のスペシャル消しですが、
            // 効果が一定時間続くものがあります（スピードUP/DOWN、クモの巣）。
            // これらが発動している間は、次のスペシャルは発動しません。
            //-------------------------------------------------//        
            
            // 位置の調整
            if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
                leftRouletteScrView_.contentOffset  = CGPointMake(0,angleL_);
                rightRouletteScrView_.contentOffset = CGPointMake(0,angleR_);      
            }else{
                leftRouletteScrView_.contentOffset  = CGPointMake(0,angleL_*2.1);
                rightRouletteScrView_.contentOffset = CGPointMake(0,angleR_*2.1);               
            }
            
            // 左のルーレットの状態確認
            switch (angleL_) {
                case 0:
                    scale_ = 2;
                    break;
                case 40:
                    scale_ = 3;
                    break;
                case 80:
                    scale_ = 4;
                    break;
                default:
                    break;
            }
            
            // 右のルーレットの状態確認
            switch (angleR_) {
                    // マックス
                case 0:
                    boardImgView_.image = [UIImage imageNamed:NSLocalizedString(@"game_speedup.png",@"")];
                    effectType_     = 1;
                    effectSkipFlg_  = YES;                    
                    [self boardDown];
                    break;
                    // レオ
                case 40:
                    boardImgView_.image = [UIImage imageNamed:NSLocalizedString(@"game_scoreup.png",@"")];
                    effectType_     = 2;
                    effectSkipFlg_  = NO;
                    [self boardDown];
                    break;
                    // ネッティー
                case 80:
                    boardImgView_.image = [UIImage imageNamed:NSLocalizedString(@"game_superstickytrap.png",@"")];
                    effectType_     = 3;
                    effectSkipFlg_  = YES;
                    [self boardDown];
                    break;
                    // ピッポ
                case 120:
                    boardImgView_.image = [UIImage imageNamed:NSLocalizedString(@"game_speeddown.png",@"")];
                    effectType_     = 4;
                    effectSkipFlg_  = YES;
                    [self boardDown];
                    break;
                    // ナッチ
                case 160:
                    boardImgView_.image = [UIImage imageNamed:NSLocalizedString(@"game_scoredown.png",@"")];
                    effectType_     = 5;
                    effectSkipFlg_  = NO;
                    [self boardDown];
                    break;
                    // ハッピー
                case 200:
                    boardImgView_.image = [UIImage imageNamed:NSLocalizedString(@"game_happytyphoon.png",@"")];
                    effectType_     = 6;
                    effectSkipFlg_  = YES;
                    [self boardDown];
                    break;         
                default:
                    break;
            }
        }else{
            // 効果音の再生
            [self playSound:kSoundType4];
        }
        
        // 一時ブロックをクリア
        [self performSelector:@selector(clearBlock) withObject:nil afterDelay:0.3];
    }else{
        if(!addSkipFlg_ && !allSkipFlg_){
            // 処理が完了するまで2重起動させない
            addSkipFlg_ = YES;
            
            // 新しいブロックの追加チェック
            [self performSelector:@selector(addBlock) withObject:nil afterDelay:0.3];
        }
    }
}

// いらないブロックを削除します。
-(void)clearBlock
{
    // 消しアイコンの回収
    for (int i=0; i<[dataArray_ count]; i++) {
        NSMutableArray *blockArray = [dataArray_ objectAtIndex:i];
        
        for (int p=0; p<[blockArray count]; p++) {
            NSString *blockString = [blockArray objectAtIndex:p];
            
            if([blockString isEqualToString:@"98"]){
                [blockArray replaceObjectAtIndex:p withObject:[NSString stringWithFormat:@"00"]];
                // 消した数をカウント
                clearCount_ += 1;
                
                // 難易度の再設定
                [self checkDifficulty];
            }
        }
    }
    
    // 不要な空白をクリア
    [self dropBlock:NULL];
}

// 新しいブロックを追加します。
- (void)addBlock
{    
    // 新しく置ける場所がカラなのを確認して追加
    if ([[[dataArray_ objectAtIndex:0] objectAtIndex:2] isEqualToString:@"00"] && [[[dataArray_ objectAtIndex:0] objectAtIndex:3] isEqualToString:@"00"]) {
        
        // クモの巣が残っている場合は消す
        if(clearTrapFlg_){
            
            // フラグの一括処理（クモの巣）
            for (int i=0; i<[dataArray_ count]; i++) {
                NSMutableArray *blockArray = [dataArray_ objectAtIndex:i];
                
                for (int p=0; p<[blockArray count]; p++) {
                    NSString *charString = [[blockArray objectAtIndex:p]substringToIndex:1];
                    NSString *condString = [[blockArray objectAtIndex:p]substringFromIndex:1];
                    
                    if([condString isEqualToString:@"3"]){
                        if([charString isEqualToString:@"0"]){
                            [blockArray replaceObjectAtIndex:p withObject:[NSString stringWithFormat:@"00"]];
                        }else{
                            [blockArray replaceObjectAtIndex:p withObject:[NSString stringWithFormat:@"%@1",charString]];
                        }
                    }
                }
            }
            // 不要な空白をクリア
            [self dropBlock:NULL];
            
            // フラグをOFFに
            clearTrapFlg_ = NO;
            
            // 処理スキップフラグをOFFに
            effectSkipFlg_ = NO;
            
            // ボードをぜんぶ上げる
            [self boardUpFull];
        }
        
        // 葉っぱを揺らす
        vy_ += 10;  
        
        // ブロックの絵柄決定ロジック（左のブロック）
        // STEP1 乱数の初期化（秒数が同じになるので、倍率を変更）
        srand([[NSDate date] timeIntervalSinceReferenceDate]*1);
        
        // STEP2 乱数発生（0〜15までの値を出す）
        int val1 = rand()%16;
        
        // STEP3 条件分岐（サルとリスを多めに、SPは少なめに）
        switch (val1) {
            case 0:
                val1 = 1;
                break;
            case 1:
                val1 = 1;
                break;
            case 2:
                val1 = 1;
                break;
            case 3:
                val1 = 2;
                break;
            case 4:
                val1 = 2;
                break;
            case 5:
                val1 = 2;
                break;
            case 6:
                val1 = 3;
                break;
            case 7:
                val1 = 3;
                break;
            case 8:
                val1 = 4;
                break;
            case 9:
                val1 = 4;
                break;
            case 10:
                val1 = 5;
                break;
            case 11:
                val1 = 5;
                break;
            case 12:
                val1 = 6;
                break;
            case 13:
                val1 = 6;
                break;
            case 14:
                val1 = 7;
                break;
            case 15:
                val1 = 8;
                break;
            default:
                break;
        }
        
        // ブロックの絵柄決定ロジック（右のブロック）
        // STEP1 乱数の初期化（秒数が同じになるので、倍率を変更）
        srand([[NSDate date] timeIntervalSinceReferenceDate]*2);
        
        // STEP2 乱数発生（0〜15までの値を出す）
        int val2 = rand()%16;
        
        // STEP3 条件分岐（サルとリスを多めに、SPは少なめに）
        switch (val2) {
            case 0:
                val2 = 1;
                break;
            case 1:
                val2 = 1;
                break;
            case 2:
                val2 = 1;
                break;
            case 3:
                val2 = 2;
                break;
            case 4:
                val2 = 2;
                break;
            case 5:
                val2 = 2;
                break;
            case 6:
                val2 = 3;
                break;
            case 7:
                val2 = 3;
                break;
            case 8:
                val2 = 4;
                break;
            case 9:
                val2 = 4;
                break;
            case 10:
                val2 = 5;
                break;
            case 11:
                val2 = 5;
                break;
            case 12:
                val2 = 6;
                break;
            case 13:
                val2 = 6;
                break;
            case 14:
                val2 = 7;
                break;
            case 15:
                val2 = 8;
                break;
            default:
                break;
        }
        
        NSString *tempNum1 = [NSString stringWithFormat:@"%d1",val1];
        NSString *tempNum2 = [NSString stringWithFormat:@"%d2",val2];
        
        [[dataArray_ objectAtIndex:0] replaceObjectAtIndex:2 withObject:tempNum1];
        [[dataArray_ objectAtIndex:0] replaceObjectAtIndex:3 withObject:tempNum2];
        
        // スタート時処理抜け対応
        moveCount_ = 2;
        
        // オブジェクトの表示
        [self dispBlock];
        
        // 処理を受け付ける
        addSkipFlg_ = NO;
        
        // 新しく置ける場所が無いのでゲームオーバー
    }else{
        [self gameOver];
    }
}

// ブロックを一括で描画します。
- (void)dispBlock
{        
    // カンスト対策
    if(score_ >= 999999999){
        score_ = 999999999;
    }
    
    // スコア表示        
    scoreImgView1_.image = [UIImage imageNamed:[NSString stringWithFormat:@"%@.png",[[NSString stringWithFormat:@"%09d",score_] substringWithRange:NSMakeRange(8,1)]]];
    scoreImgView2_.image = [UIImage imageNamed:[NSString stringWithFormat:@"%@.png",[[NSString stringWithFormat:@"%09d",score_] substringWithRange:NSMakeRange(7,1)]]];
    scoreImgView3_.image = [UIImage imageNamed:[NSString stringWithFormat:@"%@.png",[[NSString stringWithFormat:@"%09d",score_] substringWithRange:NSMakeRange(6,1)]]];
    scoreImgView4_.image = [UIImage imageNamed:[NSString stringWithFormat:@"%@.png",[[NSString stringWithFormat:@"%09d",score_] substringWithRange:NSMakeRange(5,1)]]];
    scoreImgView5_.image = [UIImage imageNamed:[NSString stringWithFormat:@"%@.png",[[NSString stringWithFormat:@"%09d",score_] substringWithRange:NSMakeRange(4,1)]]];
    scoreImgView6_.image = [UIImage imageNamed:[NSString stringWithFormat:@"%@.png",[[NSString stringWithFormat:@"%09d",score_] substringWithRange:NSMakeRange(3,1)]]];
    scoreImgView7_.image = [UIImage imageNamed:[NSString stringWithFormat:@"%@.png",[[NSString stringWithFormat:@"%09d",score_] substringWithRange:NSMakeRange(2,1)]]];
    scoreImgView8_.image = [UIImage imageNamed:[NSString stringWithFormat:@"%@.png",[[NSString stringWithFormat:@"%09d",score_] substringWithRange:NSMakeRange(1,1)]]];
    scoreImgView9_.image = [UIImage imageNamed:[NSString stringWithFormat:@"%@.png",[[NSString stringWithFormat:@"%09d",score_] substringWithRange:NSMakeRange(0,1)]]];
    
    // ブロックの表示リセット（基本ブロック）
    for (int p=0; p<[blockArray_ count]; p++) {
        // イメージビューを引っ張ってくる
        UIImageView *blockImage = [blockArray_ objectAtIndex:p];
        
        // 消しインジケーターを削除
        if ([blockImage.subviews count] != 0) {
            for (int c=0; c<[blockImage.subviews count]; c++) {
                [[blockImage.subviews objectAtIndex:c] removeFromSuperview];
            }
        }
        // イメージを空白に
        blockImage.image = [UIImage imageNamed:@""];
    }
    // ブロックの表示リセット（クモの巣と台風ブロック）
    for (int i=0; i<[blockArraySP_ count]; i++) {
        // イメージビューを引っ張ってくる
        UIImageView *blockImageSP = [blockArraySP_ objectAtIndex:i];
        // イメージを空白に
        blockImageSP.image = [UIImage imageNamed:@""];
        blockImageSP.alpha = 1.0;
    }
    
    // ブロックの位置用の変数
    NSInteger blockIndex = 0;
    
    for (int i=0; i<11; i++) {
        NSMutableArray *blockArray = [dataArray_ objectAtIndex:i];
        for (int c=0; c<6; c++) {
            NSString *charString = [[blockArray objectAtIndex:c] substringToIndex:1];
            NSString *condString = [[blockArray objectAtIndex:c] substringFromIndex:1];
            
            // イメージビューを引っ張ってくる
            UIImageView *blockImage   = [blockArray_ objectAtIndex:blockIndex];
            UIImageView *blockImageSP = [blockArraySP_ objectAtIndex:blockIndex];
            
            // オブジェクトの表示条件（空白以外なら表示）
            if(![condString isEqualToString:@"0"]){
                // No1 マイキー
                if([charString isEqualToString:@"1"]){                    
                    blockImage.image = [UIImage imageNamed:@"mikey.png"];
                    // No2 サリー
                }else if([charString isEqualToString:@"2"]){
                    blockImage.image = [UIImage imageNamed:@"sally.png"];
                    // No3 マックス
                }else if([charString isEqualToString:@"3"]){
                    blockImage.image = [UIImage imageNamed:@"max.png"];
                    // No4 ピッポ
                }else if([charString isEqualToString:@"4"]){
                    blockImage.image = [UIImage imageNamed:@"pippo.png"];
                    // No5 レオ
                }else if([charString isEqualToString:@"5"]){
                    blockImage.image = [UIImage imageNamed:@"leo.png"];
                    // No6 ナッチ
                }else if([charString isEqualToString:@"6"]){
                    blockImage.image = [UIImage imageNamed:@"natch.png"];
                    // No7 マイキーSP
                }else if([charString isEqualToString:@"7"]){
                    blockImage.image = [UIImage imageNamed:@"mikey_sp.png"];
                    // No8 サリーSP
                }else if([charString isEqualToString:@"8"]){
                    blockImage.image = [UIImage imageNamed:@"sally_sp.png"];
                    // No9 消しインジケーター
                }else if([charString isEqualToString:@"9"]){
                    UIActivityIndicatorView *indicator = [[UIActivityIndicatorView alloc] initWithFrame:CGRectMake(0.0, 0.0, blockSize_, blockSize_)];
                    
                    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
                        indicator.activityIndicatorViewStyle = UIActivityIndicatorViewStyleGray;
                    }else{
                        indicator.activityIndicatorViewStyle = UIActivityIndicatorViewStyleWhiteLarge;
                    }
                    
                    [blockImage addSubview:indicator];
                    [indicator startAnimating];
                }
            }
            // クモの巣対応
            if([condString isEqualToString:@"3"]){
                blockImageSP.image = [UIImage imageNamed:@"cobwebs.png"];
                // 台風対応
            }else if([condString isEqualToString:@"4"]){
                blockImageSP.image = [UIImage imageNamed:@"typhoon.png"];
            }
            // 位置変数に1を加算
            blockIndex += 1;
        }
    }
}

#pragma mark -
#pragma mark M-5.4 ルーレット動作についての各種処理
//------------------------------------------//
// M-5.4 ルーレット動作についての各種処理
//------------------------------------------//

// 左ルーレットの動きを設定します。
- (void)turnLeftRoulette
{
    // オフセットをずらす
    leftRouletteScrView_.contentOffset = CGPointMake(0, leftRouletteScrView_.contentOffset.y + 1);
    
    // 現在の角度を記録しつつ、しきい値を超えたら初期化しループ
    NSInteger blockSize = kBlockSizeiPhone;
    
    if (leftRouletteScrView_.contentOffset.y < blockSize_) {
        angleL_ = 0;
    }else if (leftRouletteScrView_.contentOffset.y < (blockSize_*2)) {
        angleL_ = blockSize;
    }else if (leftRouletteScrView_.contentOffset.y < (blockSize_*3)) {
        angleL_ = blockSize*2;
    }else if (leftRouletteScrView_.contentOffset.y >= (blockSize_*3)) {
        leftRouletteScrView_.contentOffset = CGPointMake(0, 0);
        angleL_ = 0;
    }
}

// 右ルーレットの動きを設定します。
- (void)turnRightRoulette
{
    // オフセットをずらす
    rightRouletteScrView_.contentOffset = CGPointMake(0, rightRouletteScrView_.contentOffset.y + 1);
    
    // 現在の角度を記録しつつ、しきい値を超えたら初期化しループ
    NSInteger blockSize = kBlockSizeiPhone;
    
    if (rightRouletteScrView_.contentOffset.y < blockSize_) {
        angleR_ = 0;
    }else if (rightRouletteScrView_.contentOffset.y <  (blockSize_*2)) {
        angleR_ = blockSize;
    }else if (rightRouletteScrView_.contentOffset.y <  (blockSize_*3)) {
        angleR_ = blockSize*2;
    }else if (rightRouletteScrView_.contentOffset.y <  (blockSize_*4)) {
        angleR_ = blockSize*3;
    }else if (rightRouletteScrView_.contentOffset.y <  (blockSize_*5)) {
        angleR_ = blockSize*4;
    }else if (rightRouletteScrView_.contentOffset.y <  (blockSize_*6)) {
        angleR_ = blockSize*5;
    }else if (rightRouletteScrView_.contentOffset.y >= (blockSize_*6)) {
        rightRouletteScrView_.contentOffset = CGPointMake(0, 0);
        angleR_ = 0;
    }
}

#pragma mark -
#pragma mark M-5.5 特殊効果についての各種処理
//------------------------------------------//
// M-5.5 特殊効果についての各種処理
//------------------------------------------//

// アクションボードを下ろします。
- (void)boardDown
{
    // ルーレットの停止
    rouletteSkipFlg_ = YES;
    
    // 落下処理停止
    allSkipFlg_ = YES;
    
    // アニメーションの設定
    [UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:0.4];
	[UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
    
    // アニメーションイベントを受け取る
	[UIView setAnimationDelegate:self];
    
    // 処理内容
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        boardImgView_.frame = CGRectMake(72.5, -20.0, 175.0, 310.0);
    }else{
        boardImgView_.frame = CGRectMake(200.25, -42.0, 367.5, 651.0);
    }
    
    // テスト用（効果を固定できます）
    //effectType_ = 1;
    
    // アニメーション終了後に実行される（効果実行）
    switch (effectType_) {
        case 1:
            [UIView setAnimationDidStopSelector:@selector(speedUp)];
            break;
        case 2:
            [UIView setAnimationDidStopSelector:@selector(scoreUp)];
            break;
        case 3:
            [UIView setAnimationDidStopSelector:@selector(stickyTrap)];
            break;
        case 4:
            [UIView setAnimationDidStopSelector:@selector(speedDown)];
            break;
        case 5:
            [UIView setAnimationDidStopSelector:@selector(scoreDown)];
            break;
        case 6:
            [UIView setAnimationDidStopSelector:@selector(happyTyphoon)];
            break;
        default:
            break;
    }
    
    // アニメーションの実行
    [UIView commitAnimations];
}

// ボーナス得点を加算します。
- (void)scoreUp
{
    // 倍率に従ってスコアを上げる
    score_ = score_ * scale_;
    
    // 効果音の再生
    [self playSound:kSoundType13];
    
    // ボードをすべて上げる
    [self boardUpFull];
}

// 得点を減算します。
- (void)scoreDown
{
    // 倍率で割ってスコアを下げる（得点が0点以上の場合のみ）
    if(score_ > 0){
        score_ = score_ / scale_;        
    }else{
        score_ = 0;
    }
    
    // 効果音の再生
    [self playSound:kSoundType14];
    
    // ボードをすべて上げる
    [self boardUpFull];
}

// ゲームスピードを上げます。
- (void)speedUp
{
    // 難易度による初期化
    switch (difficulty_) {
        case kDifficultyEasy:
            speed_ = kSpeedEasy     - (scale_ * 5);
            break;
        case kDifficultyMedium:
            speed_ = kSpeedMedium   - (scale_ * 5);
            break;
        case kDifficultyHard:
            speed_ = kSpeedHard     - (scale_ * 5);
            break;
        case kDifficultyVeryHard:
            speed_ = kSpeedVeryHard - (scale_ * 5);
            break;
        case kDifficultyExtreme:
            speed_ = kSpeedExtreme  - (scale_ * 5);
            break;
        default:
            break;
    }
    
    // 効果音の再生
    [self playSound:kSoundType15];
    
    // ボードを半分まで上げる
    [self boardUpHalf];
}

// ゲームスピードを下げます。
- (void)speedDown
{
    // 難易度による初期化
    switch (difficulty_) {
        case kDifficultyEasy:
            speed_ = kSpeedEasy     + (scale_ * 5);
            break;
        case kDifficultyMedium:
            speed_ = kSpeedMedium   + (scale_ * 5);
            break;
        case kDifficultyHard:
            speed_ = kSpeedHard     + (scale_ * 5);
            break;
        case kDifficultyVeryHard:
            speed_ = kSpeedVeryHard + (scale_ * 5);
            break;
        case kDifficultyExtreme:
            speed_ = kSpeedExtreme  + (scale_ * 5);
            break;            
        default:
            break;
    }
    
    // 効果音の再生
    [self playSound:kSoundType16];
    
    // ボードを半分まで上げる
    [self boardUpHalf];
}

// スピードを元の状態に戻します。
- (void)resetSpeed
{    
    // 難易度による初期化
    switch (difficulty_) {
        case 0:
            speed_ = kSpeedEasy;
            break;
        case 1:
            speed_ = kSpeedMedium;
            break;
        case 2:
            speed_ = kSpeedHard;
            break;
        case 3:
            speed_ = kSpeedVeryHard;
            break;
        case 4:
            speed_ = kSpeedExtreme;
            break;            
        default:
            break;
    }
    
    // ボードをぜんぶ上げる
    [self boardUpFull];
}

// クモの巣を表示します。
- (void)stickyTrap
{
    // 倍率の数分ループ
    for (int i=0; i<scale_; i++) {
        // STEP1 乱数の初期化
        srand([[NSDate date] timeIntervalSinceReferenceDate]*i);
        
        // STEP2 乱数発生（0〜5までの値を出す）
        int val1 = rand()%6;
        
        // STEP3 上3列には発生させないため、値を3ずらす
        val1 = val1 + 3;
        
        // 横軸の設定
        int val2 = rand()%6;
        
        // 対象の配列を取得
        NSMutableArray *blockArray = [dataArray_ objectAtIndex:val1];
        
        // クモの巣発生（同じ位置に出たらやり直し）
        if ([[[blockArray objectAtIndex:val2] substringFromIndex:1] isEqualToString:@"3"]){
            i -= 1;
        }else{
            // キャラクターの上に出た場合は、上からかぶせる
            NSString *tempFlag = [[blockArray objectAtIndex:val2]substringToIndex:1];
            [blockArray replaceObjectAtIndex:val2 withObject:[NSString stringWithFormat:@"%@3",tempFlag]];
        }
    }
    
    // 表示をリフレッシュ
    [self dispBlock];
    
    // 効果音の再生
    [self playSound:kSoundType11];
    
    // ボードを半分まで上げる
    [self boardUpHalf];
}

// クモの巣を表示します（その２）。
- (void)stickyTrap2
{
    // フラグを立てておく（処理はaddBlockの中で一括処理）
    clearTrapFlg_ = YES;
}

// 台風を表示します。
- (void)happyTyphoon
{    
    // 倍率の数分ループ
    for (int i=0; i<scale_; i++) {       
        // 対象の配列を取得
        NSMutableArray *blockArray = [dataArray_ objectAtIndex:9-i];
        // 台風発生
        for (int p=0; p<[blockArray count]; p++) {
            [blockArray replaceObjectAtIndex:p withObject:[NSString stringWithFormat:@"04"]];
        }
    }
    
    // 表示をリフレッシュ
    [self dispBlock];
    
    // 台風フェードイン
    for (int i=0; i<[blockArraySP_ count]-1; i++) {
        // 初期設定
        UIImageView *blockImageSP = [blockArraySP_ objectAtIndex:i];
        blockImageSP.alpha = 0.0;
        
        // フェードイン
        [UIView beginAnimations:nil context:NULL];
        [UIView setAnimationDuration:0.4];
        blockImageSP.alpha = 1.0;
        [UIView commitAnimations];
    }
    
    // 次のステップへ
    UIImageView *blockImageSP = [blockArraySP_ objectAtIndex:[blockArraySP_ count]-1];
    blockImageSP.alpha = 0.0;
    
    // フェード印
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationDuration:0.4];
    blockImageSP.alpha = 1.0;
    [UIView setAnimationDidStopSelector:@selector(happyTyphoon2)];
    [UIView setAnimationDelegate:self];
    [UIView commitAnimations];
}

// 台風を表示します（その２）。
- (void)happyTyphoon2
{    
    // 台風回転
    for (int i=0; i<[blockArraySP_ count]-1; i++) {
        UIImageView *blockImageSP = [blockArraySP_ objectAtIndex:i];
        
        // 回転
        [UIView beginAnimations:nil context:NULL];
        [UIView setAnimationDuration:1.0];
        [UIView setAnimationTransition:UIViewAnimationTransitionFlipFromRight forView:blockImageSP cache:YES];
        [UIView commitAnimations];
    }
    
    // 次のステップへ
    UIImageView *blockImageSP = [blockArraySP_ objectAtIndex:[blockArraySP_ count]-1];
    // 回転
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationDuration:1.0];
    [UIView setAnimationTransition:UIViewAnimationTransitionFlipFromRight forView:blockImageSP cache:YES];
    [UIView setAnimationDidStopSelector:@selector(happyTyphoon3)];
    [UIView setAnimationDelegate:self];
    [UIView commitAnimations];
    
    // 効果音の再生
    [self playSound:kSoundType10];
}

// 台風を表示します（その３）。
- (void)happyTyphoon3
{   
    // 台風フェードアウト
    for (int i=0; i<[blockArraySP_ count]-1; i++) {
        // 初期設定
        UIImageView *blockImageSP = [blockArraySP_ objectAtIndex:i];
        
        // フェードアウト
        [UIView beginAnimations:nil context:NULL];
        [UIView setAnimationDuration:0.6];
        blockImageSP.alpha = 0.0;
        [UIView commitAnimations];
    }
    
    // 次のステップへ
    UIImageView *blockImageSP = [blockArraySP_ objectAtIndex:[blockArraySP_ count]-1];
    // フェードアウト
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationDuration:0.6];
    blockImageSP.alpha = 0.0;
    [UIView setAnimationDidStopSelector:@selector(happyTyphoon4)];
    [UIView setAnimationDelegate:self];
    [UIView commitAnimations];
}

// 台風を表示します（その４）。
- (void)happyTyphoon4
{   
    // フラグの一括処理
    for (int i=0; i<[dataArray_ count]; i++) {
        NSMutableArray *blockArray = [dataArray_ objectAtIndex:i];
        
        for (int p=0; p<[blockArray count]; p++) {
            NSString *condString = [[blockArray objectAtIndex:p]substringFromIndex:1];            
            if([condString isEqualToString:@"4"]){
                [blockArray replaceObjectAtIndex:p withObject:[NSString stringWithFormat:@"00"]];
            }
        }
    }
    // 不要な空白をクリア
    [self dropBlock:NULL];
    
    // ボードをぜんぶ上げる
    [self boardUpFull];
}

// アクションボードを上げます（途中まで）
- (void)boardUpHalf
{
    // アニメーションの設定
    [UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:0.4];
	[UIView setAnimationCurve:UIViewAnimationCurveEaseIn];
    [UIView setAnimationDelay:0.7];    
    
    // アニメーションイベントを受け取る
	[UIView setAnimationDelegate:self];
    
    // 処理内容
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        boardImgView_.frame = CGRectMake(72.5, -230.0, 175.0, 310.0); 
    }else{
        boardImgView_.frame = CGRectMake(200.25, -483.0, 367.5, 651.0);
    }
    
    // 効果の持続
    [UIView setAnimationDidStopSelector:@selector(effectDuration)];
    
    // アニメーションの実行
    [UIView commitAnimations];
}

// 各種持続系効果の終了を待ちます。
- (void)effectDuration
{
    // ルーレットの再開
    rouletteSkipFlg_ = NO;  
    
    // 落下処理の再開
    allSkipFlg_ = NO;
    
    // 待機後実行される（各種処理の片付け）
    switch (effectType_) {
        case 1:
            [self performSelector:@selector(resetSpeed) withObject:nil afterDelay:10];
            break;
        case 3:
            [self performSelector:@selector(stickyTrap2) withObject:nil afterDelay:10];
            break;
        case 4:
            [self performSelector:@selector(resetSpeed) withObject:nil afterDelay:10];
            break;
        default:
            break;
    }
}

// アクションボードを上げます（全上げ）
- (void)boardUpFull
{
    // アニメーションの設定
    [UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:0.4];
	[UIView setAnimationCurve:UIViewAnimationCurveEaseIn];
    [UIView setAnimationDelay:0.7];
    
    // アニメーションイベントを受け取る
	[UIView setAnimationDelegate:self];
    
    // 処理内容
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        boardImgView_.frame = CGRectMake(72.5, -310.0, 175.0, 310.0); 
    }else{
        boardImgView_.frame = CGRectMake(200.25, -651.0, 367.5, 651.0); 
    }
    
    // アニメーション終了後に実行される（ゲームの再開）
    [UIView setAnimationDidStopSelector:@selector(restartGame)];
    
    // アニメーションの実行
    [UIView commitAnimations];
}

// 効果終了、通常ゲームを再開します。
- (void)restartGame
{
    // ルーレットの再開
    rouletteSkipFlg_ = NO;
    
    // 落下処理の再開
    allSkipFlg_ = NO;
    
    // ブロックの追加を許可
    //addSkipFlg_ = NO;
    
    // 効果を実行可能に
    effectSkipFlg_ = NO;
}

#pragma mark -
#pragma mark M-5.6 その他ボードについての各種処理
//------------------------------------------//
// M-5.6 その他ボードについての各種処理
//------------------------------------------//

// スタート画面のボードを隠します。
- (void)startBoardHide
{
    // アニメーションの設定
    [UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:1.0];
	[UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
    [UIView setAnimationDelay:0];
    
    // アニメーションイベントを受け取る
	[UIView setAnimationDelegate:self];
    
    // アニメーション終了後に実行される
    [UIView setAnimationDidStopSelector:@selector(startBoardRemove)];
    
    // 処理内容
    gameStartTitleImgView_.alpha = 0;
    gameStartTitleImgView_.transform = CGAffineTransformMakeScale(6.0, 6.0);
    
    // アニメーションの実行
    [UIView commitAnimations];
}

// スタート画面のボードを消します。
- (void)startBoardRemove
{
    // ビューから外す
    [gameStartTitleImgView_ removeFromSuperview];
}

// 全消し用のイメージを表示します。
- (void)excellentShow
{
    // ビューを透明に
    excellentTitleImgView_.alpha = 0.0;
    excellentTitleImgView_.transform = CGAffineTransformMakeScale(0.8, 0.8);
    
    // ビューを追加
    [self.view addSubview:excellentTitleImgView_];
    
    // アニメーションの設定
    [UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:0.4];
	[UIView setAnimationCurve:UIViewAnimationCurveEaseIn];
    
    // アニメーションイベントを受け取る
	[UIView setAnimationDelegate:self];
    
    // アニメーション終了後に実行される
    [UIView setAnimationDidStopSelector:@selector(excellentHide)];
    
    // 処理内容
    excellentTitleImgView_.alpha = 1.0;
    excellentTitleImgView_.transform = CGAffineTransformMakeScale(1.0, 1.0);
    
    // アニメーションの実行
    [UIView commitAnimations];
    
    // 効果音の再生
    [self playSound:kSoundType9];
}

// 全消し用のイメージを隠します。
- (void)excellentHide
{
    // アニメーションの設定
    [UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:2.0];
	[UIView setAnimationCurve:UIViewAnimationCurveEaseIn];
    [UIView setAnimationDelay:0.6];
    
    // アニメーションイベントを受け取る
	[UIView setAnimationDelegate:self];
    
    // アニメーション終了後に実行される
    [UIView setAnimationDidStopSelector:@selector(excellentRemove)];
    
    // 処理内容
    excellentTitleImgView_.alpha = 0.0;
    
    // アニメーションの実行
    [UIView commitAnimations];
}

// 全消し用のイメージを消します。
- (void)excellentRemove
{
    // ビューから外す
    [excellentTitleImgView_ removeFromSuperview];
}

#pragma mark -
#pragma mark M-5.7 その他の処理いろいろ
//------------------------------------------//
// M-5.7 その他の処理いろいろ
//------------------------------------------//

// 消した数に応じて難易度を変更します。
- (void)checkDifficulty
{
    // 消した数に応じてゲーム内難易度UP
    switch (difficulty_) {
        case kDifficultyEasy:
            // EasyからMediumへ
            if (clearCount_ >= kEtoMCount){
                difficulty_ = kDifficultyMedium;
                speed_      = kSpeedMedium;
            }
            break;
        case kDifficultyMedium:
            // MediumからHardへ
            if (clearCount_ >= kMtoHCount){
                difficulty_ = kDifficultyHard;
                speed_      = kSpeedHard;
            }
            break;
        case kDifficultyHard:
            // HardからVeryHardへ
            if (clearCount_ >= kHtoVCount){
                difficulty_ = kDifficultyVeryHard;  
                speed_      = kSpeedVeryHard;
            }
            break;
        case kDifficultyVeryHard:
            // VeryHardからExtremeへ
            if (clearCount_ >= kVtoECount){
                difficulty_ = kDifficultyExtreme; 
                speed_      = kSpeedExtreme;
            }
            break;
        case kDifficultyExtreme:
            break;
        default:
            break;
    }
}

// 各種効果音を再生します。
- (void)playSound:(NSInteger)soundType
{
    // 指定された音を鳴らす
    switch (soundType) {
        case kSoundType1:
            AudioServicesPlaySystemSound(gameSound1_);
            break;
        case kSoundType2:
            AudioServicesPlaySystemSound(gameSound2_);
            break;
        case kSoundType3:
            AudioServicesPlaySystemSound(gameSound3_);
            break;
        case kSoundType4:
            AudioServicesPlaySystemSound(gameSound4_);
            break;
        case kSoundType5:
            AudioServicesPlaySystemSound(gameSound5_);
            break;
        case kSoundType6:
            AudioServicesPlaySystemSound(gameSound6_);
            break;
        case kSoundType7:
            AudioServicesPlaySystemSound(gameSound7_);
            break;
        case kSoundType8:
            AudioServicesPlaySystemSound(gameSound8_);
            break;
        case kSoundType9:
            AudioServicesPlaySystemSound(gameSound9_);
            break;
        case kSoundType10:
            AudioServicesPlaySystemSound(gameSound10_);
            break;
        case kSoundType11:
            AudioServicesPlaySystemSound(gameSound11_);
            break;
        case kSoundType12:
            AudioServicesPlaySystemSound(gameSound12_);
            break;
        case kSoundType13:
            AudioServicesPlaySystemSound(gameSound13_);
            break;
        case kSoundType14:
            AudioServicesPlaySystemSound(gameSound14_);
            break;
        case kSoundType15:
            AudioServicesPlaySystemSound(gameSound15_);
            break;
        case kSoundType16:
            AudioServicesPlaySystemSound(gameSound16_);
            break;
        default:
            break;
    }
}

// 加速度の数値に従って、葉っぱを動かします。
// 画面から飛び出してしまわないように、画面の辺に対して衝突判定を行います。
- (void)moveReef
{
	// 速度に加速度をプラス
	vx_ = vx_ + accelX_;
	vy_ = vy_ - accelY_;
	
	// 位置情報に速度をプラス
	posX_ = posX_ + vx_;
	posY_ = posY_ - vy_;
    
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        // 衝突判定(X軸左方向)
        if(posX_ <= leafMoreImgView_.frame.size.width/2){
            vx_ *= -0.8;
            posX_ = leafMoreImgView_.frame.size.width/2;
        }
        
        // 衝突判定（X軸右方向）
        if(posX_ >= 320 - leafMoreImgView_.frame.size.width/2){
            vx_ *= -0.8;
            posX_ = 320 - leafMoreImgView_.frame.size.width/2;
        }
        
        // 衝突判定(Y軸上方向)
        if(posY_ <= leafMoreImgView_.frame.size.height/2 -50){
            vy_ *= -0.8;
            posY_ = leafMoreImgView_.frame.size.height/2 - 50;
        }
        
        // 衝突判定(Y軸下方向)
        if(posY_ >= leafMoreImgView_.frame.size.height/2){
            vy_ *= -0.8;
            posY_ = leafMoreImgView_.frame.size.height/2;
        } 
    }else{
        // 衝突判定(X軸左方向)
        if(posX_ <= leafMoreImgView_.frame.size.width/2){
            vx_ *= -0.8;
            posX_ = leafMoreImgView_.frame.size.width/2;
        }
        
        // 衝突判定（X軸右方向）
        if(posX_ >= 768 - leafMoreImgView_.frame.size.width/2){
            vx_ *= -0.8;
            posX_ = 768 - leafMoreImgView_.frame.size.width/2;
        }
        
        // 衝突判定(Y軸上方向)
        if(posY_ <= leafMoreImgView_.frame.size.height/2 -105){
            vy_ *= -0.8;
            posY_ = leafMoreImgView_.frame.size.height/2 - 105;
        }
        
        // 衝突判定(Y軸下方向)
        if(posY_ >= leafMoreImgView_.frame.size.height/2){
            vy_ *= -0.8;
            posY_ = leafMoreImgView_.frame.size.height/2;
        } 
    }
    
	// 葉っぱの場所を修正
	leafMoreImgView_.center = CGPointMake(posX_, posY_);
}

#pragma mark -
#pragma mark M-5.8 Twitter関連の処理
//------------------------------------------//
// M-5.8 Twitter関連の処理
//------------------------------------------//

// つぶやける状態かどうかの状況をチェックします。
- (void)checkTwitter
{
    // 送信可否をチェック
    if ([TWTweetComposeViewController canSendTweet]) {
        // ボタンを表示
        [gameOverScrView_ addSubview:tweetButton_];
    }
}

// Twitterの画面を表示します。
- (void)showTwitter
{    
    // ツイート画面を生成する
    TWTweetComposeViewController *tweetView = [[TWTweetComposeViewController alloc] init];
    
    // 初期表示用の文字列を準備する（数字桁切り）
    NSNumberFormatter *formatter=[[NSNumberFormatter alloc] init];
    [formatter setPositiveFormat:@"#,##0"];
    NSString *tempStr = [formatter stringFromNumber:[NSNumber numberWithInt:score_]];
    [tweetView setInitialText:[NSString stringWithFormat:NSLocalizedString(@"The score this time was \"%@\"! #saruris", @""),tempStr]];
    
    // ツイート結果
    [tweetView setCompletionHandler:^(TWTweetComposeViewControllerResult result) {
        switch (result) {
            case TWTweetComposeViewControllerResultCancelled:
                [self dismissModalViewControllerAnimated:YES];
                break;
            case TWTweetComposeViewControllerResultDone:
                [self dismissModalViewControllerAnimated:YES];
                break;
            default:
                break;
        }            
    }];
    
    // ツイート画面をモーダル表示
    [self presentModalViewController:tweetView animated:YES];
    
    // 効果音の再生
    [self playSound:kSoundType6];
}

#pragma mark -
#pragma mark M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//

// 加速度センサーから傾きの値を取得します。
// 加速度センサーに設定したupdateIntervalの間隔で処理が繰り返されます。
- (void)accelerometer:(UIAccelerometer *)accelerometer didAccelerate:(UIAcceleration *)acceleration
{
	// 傾きを変数に格納
	accelX_ = acceleration.x;
	accelY_ = acceleration.y;
	accelZ_ = acceleration.z;
    
	// 葉っぱを動かす
	[self moveReef];
}

// スコアを送信します。
- (void)submitScore:(NSInteger)score forCategory:(NSString*)category
{
    // スコアの送信（リーダーボードIDはiTunesで設定済み）
    GKScore *scoreReporter = [[GKScore alloc] initWithCategory:category];
    scoreReporter.value = score;
    
    // エラーハンドリング
    [scoreReporter reportScoreWithCompletionHandler:^(NSError *error) {
        if(error != nil) {
            //NSLog(@"送信失敗");
        } else {
            //NSLog(@"送信成功");
        }
    }];
}

#pragma mark -
#pragma mark M-6.1 ビューのあれこれをイジろうブロック
//------------------------------------------//
// M-6.1 ビューのあれこれをイジろうブロック
//------------------------------------------//

// ビューが表示される「前」にこの処理が呼ばれます。
- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

// ビューが表示された「後」にこの処理が呼ばれます。
- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

// ビューが非表示にされる「前」にこの処理が呼び出されます。
- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
    
    // タイマーの停止
    [gameTimer_ invalidate];
    
    // 音楽を止めて初期化
    if ([gameAudioNormal_ isPlaying]) {
        [gameAudioNormal_ stop];    
        gameAudioNormal_.currentTime = 0.0;
    }
    if ([gameAudioPanic_ isPlaying]) {
        [gameAudioPanic_ stop];
        gameAudioPanic_.currentTime  = 0.0;
    }
    if([musicPlayer_ playbackState] != MPMusicPlaybackStateStopped){
        [musicPlayer_ stop];
    }
}

// ビューが非表示にされた「後」にこの処理が呼び出されます。
- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

#pragma mark -
#pragma mark M-6.2 ローテーションをイジろうブロック
//------------------------------------------//
// M-6.2 ローテーションをイジろうブロック
//------------------------------------------//

// iPhone/iPadが倒された時にローテーションをサポートするかどうかを設定します。
// YESが返るようにするとその方向に対してローテーションが作動するようになります。
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // iPhoneの場合
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation == UIInterfaceOrientationPortrait                  //正しい向き
                //||interfaceOrientation == UIInterfaceOrientationLandscapeLeft         //右に倒した場合
                //||interfaceOrientation == UIInterfaceOrientationLandscapeRight		//左に倒した場合
                //||interfaceOrientation == UIInterfaceOrientationPortraitUpsideDown	//逆さまにした場合
                );
    // iPadの場合
    } else {
        return (interfaceOrientation == UIInterfaceOrientationPortrait                  //正しい向き
                //||interfaceOrientation == UIInterfaceOrientationLandscapeLeft         //右に倒した場合
                //||interfaceOrientation == UIInterfaceOrientationLandscapeRight		//左に倒した場合
                //||interfaceOrientation == UIInterfaceOrientationPortraitUpsideDown	//逆さまにした場合
                );
    }
}

#pragma mark -
#pragma mark M-6.3 メモリー管理をイジろうブロック
//------------------------------------------//
// M-6.3 メモリー管理をイジろうブロック
//------------------------------------------//

// View Controllerに関連付けられているカスタムデータ構造のうち、
// 重要でないものを解放するには、このメソッドを使用します。なんてアップルも言っています。
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

// インスタンス化したオブジェクトのメモリを解放します。
- (void)viewDidUnload
{
    [super viewDidUnload];
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
