//----------------------------------------------------------------------------//
//  ViewController.m
//  SampleProject
//  Created by Takashi Kawasaki.
//  Creation date    2012/4/4
//  Last update date 2012/4/4
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "ViewController.h"

@interface ViewController ()
@end

//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
@implementation ViewController

//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
- (void)configureView
{
	NSArray *segmentTextContent = [NSArray arrayWithObjects: @"マイキー", @"サリー", @"マックス", nil];
    
	UISegmentedControl *customSegment1 = [[UISegmentedControl alloc] initWithItems:segmentTextContent];
	customSegment1.frame = CGRectMake(40.0, 160.0, 240.0, 40.0);
	customSegment1.segmentedControlStyle = UISegmentedControlStylePlain;
	customSegment1.selectedSegmentIndex = 0;
	[customSegment1 addTarget:self action:@selector(action:) forControlEvents:UIControlEventValueChanged];
    [self.view addSubview:customSegment1];
	
	UISegmentedControl *customSegment2 = [[UISegmentedControl alloc] initWithItems:segmentTextContent];
    customSegment2.frame = CGRectMake(40.0, 260.0, 240.0, 40.0);
	customSegment2.segmentedControlStyle = UISegmentedControlStyleBar;
    customSegment2.tintColor = [UIColor redColor];
    customSegment2.selectedSegmentIndex = 0;
    [customSegment2 addTarget:self action:@selector(action:) forControlEvents:UIControlEventValueChanged];
    [self.view addSubview:customSegment2];
}

//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//
- (void)action:(id)sender
{
    UISegmentedControl *tempSegment = sender;
    NSLog(@"選択されたセグメントは『%d番』です！",tempSegment.selectedSegmentIndex);
}

//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
