//----------------------------------------------------------------------------//
//  ViewController.m
//  SampleProject
//  Created by Takashi Kawasaki.
//  Creation date    2012/4/4
//  Last update date 2012/4/4
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "ViewController.h"

@interface ViewController ()
@end

//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
@implementation ViewController

//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
- (void)configureView
{
    NSLog(@"●--Arrayのログ--●");
    NSArray *array = [NSArray arrayWithObjects:
                      @"MIKEY", @"SALLY", @"MAX", @"PIPPO",
                      nil];
	NSInteger arrayCount = [array count];				  
    NSString *arrayString = [array objectAtIndex:3];
    BOOL arrayFlg = [array containsObject:@"MIKEY"];
    
    NSLog(@"配列の中身は『%@』です。" ,array);
    if (arrayFlg){
        NSLog(@"配列の個数は『%d個』、4個目の値は『%@』です。配列の中に『MIKEY』という文字があります。",arrayCount,arrayString);        
    }else{
        NSLog(@"配列の個数は『%d個』、4個目の値は『%@』です。配列の中に『MIKEY』という文字はありません。",arrayCount,arrayString);   
    }
	
    NSLog(@"●--NSMutableArrayのログ--●");
    NSLog(@"●--配列を作る--●");
    NSMutableArray *mutableArray = [NSMutableArray arrayWithObjects:
                                    @"LEO", @"NATCH", @"NETTY", @"HAPPY",
                                    nil];
    NSLog(@"配列の中身は『%@』です。" ,mutableArray);
    NSLog(@"値の個数は『%d個』です。",[mutableArray count]);
    
    NSLog(@"●--2番目にデキオを加える--●");
	[mutableArray insertObject:@"DEKIO" atIndex:1];
    NSLog(@"配列の中身は『%@』です。" ,mutableArray);
    NSLog(@"値の個数は『%d個』です。",[mutableArray count]); 
    
    NSLog(@"●--1番目の値をカバ太に入れ替える--●");
	[mutableArray replaceObjectAtIndex:0 withObject:@"KABATA"];
    NSLog(@"配列の中身は『%@』です。" ,mutableArray);
    NSLog(@"値の個数は『%d個』です。",[mutableArray count]);
	
    NSLog(@"●--3番目と4番目の値を入れ替える--●");
	[mutableArray exchangeObjectAtIndex:2 withObjectAtIndex:3];
    NSLog(@"配列の中身は『%@』です。" ,mutableArray);
    NSLog(@"値の個数は『%d個』です。",[mutableArray count]);
	
    NSLog(@"●--5番目の値を削除する--●");
	[mutableArray removeObjectAtIndex:4];
    NSLog(@"配列の中身は『%@』です。" ,mutableArray);
    NSLog(@"値の個数は『%d個』です。",[mutableArray count]);   
	
    NSLog(@"●--全ての値を削除する--●");
	[mutableArray removeAllObjects];
    NSLog(@"配列の中身は『%@』です。" ,mutableArray);
    NSLog(@"値の個数は『%d個』です。",[mutableArray count]);
}

//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//

//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
