//----------------------------------------------------------------------------//
//  ViewController.m
//  SampleProject
//  Created by Takashi Kawasaki.
//  Creation date    2012/4/4
//  Last update date 2012/4/4
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "ViewController.h"

@interface ViewController ()
@end

//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
@implementation ViewController

//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
- (void)configureView
{
    UIButton *customButton1 = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    customButton1.frame = CGRectMake(40.0, 160.0, 240.0, 40.0);
    [customButton1 setTitle:@"オーディオプレーヤー" forState:UIControlStateNormal];
    [customButton1 addTarget:self action:@selector(playAudio) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:customButton1];
	
    UIButton *customButton2 = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	customButton2.frame = CGRectMake(40.0, 260.0, 240.0, 40.0);
    [customButton2 setTitle:@"システムサウンド" forState:UIControlStateNormal];
    [customButton2 addTarget:self action:@selector(playSound) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:customButton2];
    
    NSString *audioPath = [[NSBundle mainBundle] pathForResource:@"bgm" ofType:@"mp3"];  
    NSURL *audioUrl = [NSURL fileURLWithPath:audioPath];
    customAudioPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:audioUrl error:nil]; 
    customAudioPlayer.currentTime = 0.0;
    customAudioPlayer.volume = 1.0;
    customAudioPlayer.numberOfLoops = -1;  
    [customAudioPlayer prepareToPlay];
    
    NSString *soundPath = [[NSBundle mainBundle] pathForResource:@"se" ofType:@"wav"];
	NSURL *soundUrl = [NSURL fileURLWithPath:soundPath];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)soundUrl, &customSystemSoundID);
}

//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//
- (void)playAudio
{
	[customAudioPlayer play];
}

- (void)playSound
{
	AudioServicesPlaySystemSound(customSystemSoundID);
}

//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
